c       ===========================================================================
       PROGRAM GET_TORUS_COLORS
c       ---------------------------------------------------------------------------
c       Last Version: Stefano Berta, October 16th, 2015


       implicit none
       character infile(2)*80,outfile*80,user_filt*80
       integer nmax,largo
       parameter(nmax=70)
       character*10 filt_name(nmax)
       character filter_header*2500
       integer niw,nage,index,io,nfilt_use,kfile
       integer nfilt_not_use
       integer k_use(nmax),filt_id_use(nmax)
       integer k_not_use(nmax)
       integer i,nc,imod,nburst,k,aux_read
       real z,tform,gamma,zmet,tauv0,mu,mstr1,mstr0,mstry
       real tlastburst,age_wm,age_wr,xaux(24)
       real fmu,ldtot,fbc,aux,lha,lhb
       real wl(6918),fprop(6918),fprop0(6918)
c       !CB93,CB07 -- 6918; CB08 -- 7324
       real mags(nmax),age(1000),sfr(1000)
       real mags_use(nmax)
       real fburst(5),ftot(5),sfrav(5)
       real lambda_eff(nmax),lambda_rest(nmax)
       character*6 numz
       integer nfilt,filt_id(nmax),fit(nmax),ifilt
       real h,omega,omega_lambda,clambda,q,cosmol_c,t,tu,dm,dismod
       logical sampled
       data h/70./,omega/0.30/,omega_lambda/0.70/
       data kfile/1/,aux_read/0/

!	added by Stefano Berta

	integer i_ste, j_ste, j
	integer nfiles,nfiles_used,i_files
	parameter(nfiles=22000) 			! max number of torus models
       
	integer nmax_eazy
	parameter(nmax_eazy=500)
	integer N_FILT_EAZY
	integer ID_FILT_EAZY(nmax_eazy)
	integer INDX_FILT_EAZY(nmax_eazy)
	real WAVE_FILT(10000,nmax_eazy)		! [A] !!!
	real TRANS_FILT(10000,nmax_eazy)
	real AREA_FILT(nmax_eazy)
	integer FILT_LENGTH(nmax_eazy)

        character*120 filename(nfiles)
	real*8 torus_rm(nfiles)
	real*8 torus_ct(nfiles)
	real*8 torus_ta(nfiles)
	real*8 torus_be(nfiles)
        real*8 torus_al(nfiles)
	real*8 torus_plw(nfiles)
	real*8 torus_phi(nfiles)
	
	integer ilambda
	integer maxlambda,nlambda_used
	parameter(maxlambda=200)		! max number of wavelengths in each model (178 in new Fritz+Feltre's library, as of summer 2012)

	real*8 torus_lambda(maxlambda)
	real*8 torus_lum(maxlambda)

	real*8 x_LIR_dummy(maxlambda)
	real*8 y_LIR_dummy(maxlambda)

	real*8 x_MIR1_dummy(maxlambda)		! 1.0-2.5 um
	real*8 y_MIR1_dummy(maxlambda)
	real*8 x_MIR2_dummy(maxlambda)		! 2.5-5.0 um
	real*8 y_MIR2_dummy(maxlambda)
	real*8 x_MIR3_dummy(maxlambda)		! 5-10 um
	real*8 y_MIR3_dummy(maxlambda)
	real*8 x_MIR4_dummy(maxlambda)		! 10-20 um
	real*8 y_MIR4_dummy(maxlambda)
	real*8 x_MIR5_dummy(maxlambda)		! 20-40 um
	real*8 y_MIR5_dummy(maxlambda)
	real*8 x_MIR6_dummy(maxlambda)		! 5-40 um
	real*8 y_MIR6_dummy(maxlambda)

	real*8 trapz8
	real*8 LIR_torus
	real*8 MIR1_torus
	real*8 MIR2_torus
	real*8 MIR3_torus
	real*8 MIR4_torus
	real*8 MIR5_torus
	real*8 MIR6_torus
 
	!character*30 convlib1
	!character*30 convlib2
	character*30 convlib3

	character filtfile*80

       character*20 sdummy

       character*20 lib_dir			! path of libraries directory
       character*50 torus_list			! filename of list of torii to be used (the list includes also relevant parameters for each torus model)

	character eazy_filt_info*80,eazy_filt*80


c     ---------------------------------------------------------------------------

	! read new input file
	
      close(22)

      !open(22,file='input_magphys_agn',status='old')
      open(22,file='input_sed3fit',status='old')

      read(22,*) sdummy, sdummy	 	! catalog
      read(22,*) sdummy, user_filt  	! list of filters to be used
      read(22,*) sdummy, filtfile	! magphys filters library
      read(22,*) sdummy, eazy_filt_info	! eazy filters info
      read(22,*) sdummy, eazy_filt	! eazy filters library
      read(22,*) sdummy, sdummy 	! opt library (magphys)
      read(22,*) sdummy, sdummy		! opt library bis (magphys)
      read(22,*) sdummy, sdummy 	! IR library
      read(22,*) sdummy, torus_list	! list of torii
      read(22,*) sdummy, sdummy		! main name of convolved optical library (path and redshift are automatically added)
      read(22,*) sdummy, sdummy		! main name of convolved infrared library (path and redshift are automatically added)
      read(22,*) sdummy, convlib3	! main name of convolved torus library (path and redshift are automatically added)
      read(22,*) sdummy, lib_dir	! dir where the convolved libraries are stored
      
      close(22)


c       ===========================================================================




c       INPUT files: spectral libraries (stellar populations + dust attenuation)
c	Get binary file names and paths from environment variable OPTILIB & OPTILIBIS
!       call getenv('OPTILIB',infile(1))
!       call getenv('OPTILIBIS',infile(2))

c       INPUT redshift
       write (6,'(x,a,$)') 'Enter redshift = '
       read (5,*) z

c       OUTPUT file: catalogue of parameters & magnitudes @ redshift z
       write(numz,'(f6.4)') z
       outfile=convlib3(1:largo(convlib3))//numz//'.lbr'
       close (30)
       open (30,file=outfile,status='unknown')

c       Cosmological parameters
        write (6,'(/x,a,f4.0,a,f5.3,a,$)') 'Enter Cosmology [default: 70.,0.3,0.7]'
10      write (6,'(x,a,f4.0,a,f5.2,a,f5.2,a,$)')  'Enter Ho [',h,'], Omega [',
     +          omega,'], Omega_lambda [',omega_lambda,'] = '
        call nread(xaux,nc,*10,*11)
11      if (nc.gt.0.) then
           h=xaux(1)
           omega=xaux(2)
           omega_lambda=xaux(3)
        endif

c       Obtain cosmological constant and q
        clambda=cosmol_c(h,omega,omega_lambda,q)

c       Age of the universe at z
        tu=t(h,q,z,clambda)*1.e9
        write (6,'(x,a,f4.2,a,f6.2,a  )') 'Age of this universe at z=',z,
     +                                    ':',tu/1.e9,' Gyr'

c       Distance modulus 
        dm=dismod(h,q,z)
        write (6,'(x,a,f4.2,a,f6.2,a  )') 'Distance modulus at z=',z,
     +                                    ':',dm

c       Read filter file
       !call getenv('USER_FILTERS',user_filt)
	close(22)
       open(22,file=user_filt,status='old')
       do i=1,1
	  read(22,*)
	enddo
	io=0
	ifilt=0
	do while(io.eq.0)
	   ifilt=ifilt+1
	   read(22,*,iostat=io) filt_name(ifilt),lambda_eff(ifilt),filt_id(ifilt),fit(ifilt)
	enddo
	nfilt=ifilt-1
	
c       Compute optical colours for all filters sampling the rest-frame
c       emission up to 1000 microns (no torus model extends further)
c       (if lambda > 1000 microns, contribution from SPs is negligible)

	! clean arrays
	
	do I=1,nmax
		k_use(i)=0
		filt_id_use(i)=0
		k_not_use(i)=0
	end do 

c       count nr of filters to use: nfilt_use
	nfilt_use=0
	nfilt_not_use=0

	do i=1,nfilt
	   lambda_rest(i)=lambda_eff(i)/(1.+z)
	   if (lambda_rest(i).lt.1000.) then
	      nfilt_use=nfilt_use+1
	      k_use(nfilt_use)=i
	   else
	      nfilt_not_use=nfilt_not_use+1
	      k_not_use(nfilt_not_use)=i
	   endif
	enddo

	!write(filter_header,*) (filt_name(k_use(k)),k=1,nfilt_use)
	write(filter_header,*) (filt_name(k),k=1,nfilt)

	do k=1,nfilt_use
	   filt_id_use(k)=filt_id(k_use(k))
	enddo

c       Output File Header
c       Store cosmological parameters	 
	   write (30,'(15(a12),a4,a500)')
     +  '#      index',   ! 0: index in the OptiLIB/OptiLIBis library
     +  '          rm',   ! 1: Rmax/Rmin of torus
     +  '          ct',   ! 2: aperture angle of torus
     +  '         tau',   ! 3: tau(9.7um)
     +  '          be',   ! 4: beta in dust distribution
     +  '          al',   ! 5: gamma in dust distribution
     +  '         plw',   ! 6: power-law model? (y/n)
     +  '         phi',   ! 7: viewing angle
     +  '         LIR',   ! 8: L(8-1000 um)
     +  'L(1.0-2.5um)',	  ! 9: L(1.0-2.5 um)
     +  'L(2.5-5.0um)',	  !10: L(2.5-5.0 um)
     +  '   L(5-10um)',	  !11: L(5-10 um)
     +  '  L(10-20um)',	  !12: L(10-20 um)
     +  '  L(20-40um)',	  !13: L(20-40 um)
     +  '   L(5-40um)',	  !14: L(5-40 um)
     +  '    ',filter_header   !15--nfilt: model AB magnitudes at redshift z



! ----------------------------------------------


	! read EAZY filters file
	! note that wavelength is in [A] !!!
	
	N_FILT_EAZY=0
	
	N_FILT_EAZY=COUNT(filt_id_use(:).gt.1e4)

	
	if(N_FILT_EAZY.gt.0)then

	J=0
	DO I=1,nfilt
		IF(filt_id_use(I).gt.1e4)THEN
			J=J+1
			ID_FILT_EAZY(J)=filt_id_use(I)
			INDX_FILT_EAZY(J)=J
		END IF
	END DO

		
	CALL READ_FILTERS_EAZY(N_FILT_EAZY,ID_FILT_EAZY,WAVE_FILT,
     2	TRANS_FILT,AREA_FILT,FILT_LENGTH,eazy_filt_info,eazy_filt)

	end if


c       ---------------------------------------------------------------------------       
c       Read torus models
c       Compute magnitude for each model
c       Store parameters + magnitudes of each model in output file

	   close (29)
	   open (29,file=torus_list,status='old')

	   ! skip header (1 line)
	   read(29,*) 
	   
	   io=0
	   i_files=0
	   do while(io.eq.0)
             i_files=i_files+1
             read(29,*,iostat=io) filename(i_files), torus_rm(i_files), 
     2		torus_ct(i_files), torus_ta(i_files), torus_be(i_files),
     3		torus_al(i_files), torus_plw(i_files), torus_phi(i_files)
	     
	     !write(*,*) filename(i_files), torus_rm(i_files)

           enddo
     	   nfiles_used=i_files-1
           close(29)
           
	   !write(*,*)nfiles_used,filename(nfiles_used)
	   
	   index=0
	
	   do imod=1,nfiles_used
		 
		 index=index+1
	         
		 do i_ste=1,maxlambda
		 	torus_lambda(i_ste)=0.0
		 	torus_lum(i_ste)=0.0
		 end do
		 
		 
		 
		 !write(*,*) imod, index, filename(imod)  !,torus_rm(imod)
		
		 open (29,file=filename(imod),status='old')

		 ! skip header 4 lines
		 !do i_ste=1,4
		 !	read(29,*)
		 !end do
		 
		 !!! NO MORE HEADER to skip, with the new Fritz library (2012 version)
		 !!! because I got rid of it when splitting the models by phi (using a SM macro).		 
		 
		 io=0
		 ilambda=0
		 ! read model
!	         do while(io.eq.0)
	         do while(ilambda.le.(maxlambda-1))
                      ilambda=ilambda+1
		      read(29,*,iostat=io) torus_lambda(ilambda),
     2			torus_lum(ilambda)
		 
		      ! model format is: lambda[um] and luminosity[erg/s/um]
		      ! I need to turn it into lambda[A] and luminosity[Lsun/A]
		      
		      torus_lambda(ilambda)=torus_lambda(ilambda)*1.d4
		      torus_lum(ilambda)=torus_lum(ilambda)/1.d4/3.839d33
		      
		 
		 ! write(*,*)ilambda,torus_lambda(ilambda),torus_lum(ilambda)
		      
		      
                 end do
		 nlambda_used=ilambda
		 close(29)
		 
		!do i_ste=1,maxlambda
		!	write(*,*)torus_lambda(i_ste),torus_lum(i_ste) !!!!!!!
		!end do
		 
		 x_LIR_dummy(:)=torus_lambda(:)
		 y_LIR_dummy(:)=torus_lum(:)

		 x_MIR1_dummy(:)=torus_lambda(:)
		 y_MIR1_dummy(:)=torus_lum(:)
		 x_MIR2_dummy(:)=torus_lambda(:)
		 y_MIR2_dummy(:)=torus_lum(:)
		 x_MIR3_dummy(:)=torus_lambda(:)
		 y_MIR3_dummy(:)=torus_lum(:)
		 x_MIR4_dummy(:)=torus_lambda(:)
		 y_MIR4_dummy(:)=torus_lum(:)
		 x_MIR5_dummy(:)=torus_lambda(:)
		 y_MIR5_dummy(:)=torus_lum(:)
		 x_MIR6_dummy(:)=torus_lambda(:)
		 y_MIR6_dummy(:)=torus_lum(:)
		 
		 do i_ste=1,maxlambda

		 	if(x_LIR_dummy(i_ste) .lt. 8.d4 .or. 
     2			x_LIR_dummy(i_ste) .gt. 1000.d4) then

				y_LIR_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR1_dummy(i_ste) .lt. 1.d4 .or. 
     2			x_MIR1_dummy(i_ste) .gt. 2.5d4) then

				y_MIR1_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR2_dummy(i_ste) .lt. 2.5d4 .or. 
     2			x_MIR2_dummy(i_ste) .gt. 5.d4) then

				y_MIR2_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR3_dummy(i_ste) .lt. 5.d4 .or. 
     2			x_MIR3_dummy(i_ste) .gt. 10.d4) then

				y_MIR3_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR4_dummy(i_ste) .lt. 10.d4 .or. 
     2			x_MIR4_dummy(i_ste) .gt. 20.d4) then

				y_MIR4_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR5_dummy(i_ste) .lt. 20.d4 .or. 
     2			x_MIR5_dummy(i_ste) .gt. 40.d4) then

				y_MIR5_dummy(i_ste)=0.d0
				
			end if

		 	if(x_MIR6_dummy(i_ste) .lt. 5.d4 .or. 
     2			x_MIR6_dummy(i_ste) .gt. 40.d4) then

				y_MIR6_dummy(i_ste)=0.d0
				
			end if

		
		 end do
		 
		 LIR_torus=trapz8(x_LIR_dummy,y_LIR_dummy,maxlambda)
		 MIR1_torus=trapz8(x_MIR1_dummy,y_MIR1_dummy,maxlambda)
		 MIR2_torus=trapz8(x_MIR2_dummy,y_MIR2_dummy,maxlambda)
		 MIR3_torus=trapz8(x_MIR3_dummy,y_MIR3_dummy,maxlambda)
		 MIR4_torus=trapz8(x_MIR4_dummy,y_MIR4_dummy,maxlambda)
		 MIR5_torus=trapz8(x_MIR5_dummy,y_MIR5_dummy,maxlambda)
		 MIR6_torus=trapz8(x_MIR6_dummy,y_MIR6_dummy,maxlambda)
		 
		 call model_ab_color(z,torus_lambda,torus_lum,torus_lum,
     2		 nlambda_used,nfilt_use,filt_id_use,mags_use,
     +		 WAVE_FILT,TRANS_FILT,AREA_FILT,FILT_LENGTH,
     +		 filtfile)

		 ! now fill the full mags array with the used ones, 
		 ! and set to -100 all others
		 
		 do i_ste=1,nfilt_use
		  	mags(k_use(i_ste))=mags_use(i_ste)
		 end do
		 do i_ste=1,nfilt_not_use
		  	mags(k_not_use(i_ste))=-100.
		 end do
		 

		 ! few subroutines run in single precision, therefore it 
		 ! is possible to encounter underflows. 
		 ! In case this happened, I simply set the given magnitude 
		 ! to +/-100 (underflow/overflow)
		 
		 do i_ste=1,nfilt_use
		  	if(mags(k_use(i_ste)).lt.-100.) then
				mags(k_use(i_ste))=-100.
			end if
		  	if(mags(k_use(i_ste)).gt.+100.) then
				mags(k_use(i_ste))=+100.
			end if
		 end do
		 

c                   write output file:

		!write(*,*)LIR_torus

		 write (30,200) index,torus_rm(imod),torus_ct(imod),
     2		 torus_ta(imod),torus_be(imod),torus_al(imod),
     3		 torus_plw(imod),torus_phi(imod),sngl(LIR_torus),
     4		 sngl(MIR1_torus),sngl(MIR2_torus),sngl(MIR3_torus),
     5		 sngl(MIR4_torus),sngl(MIR5_torus),sngl(MIR6_torus),
     6		 (mags(i),i=1,nfilt)



 200	  format(i10,1p7e12.3,7e14.5,0p70f10.4)

	      enddo  ! on all models (imod=1,nfiles_used)



	end
c       ===========================================================================

c       ===========================================================================
	SUBROUTINE MODEL_AB_COLOR(z,x,ys,y0s,inw,nf,ifilt,mag,
     +	WAVE_FILT,TRANS_FILT,AREA_FILT,FILT_LENGTH,filtfile)
c       ===========================================================================
c	Computes AB magnitude of each model at given z in each band
c       ---------------------------------------------------------------------------
c       z    : redshift
c       x    : wavelength vector (in A)
c       ys   : total attenuated SED L_lambda (in Lsun/A)
c       y0s  : unattenuated SED L_lambda (in Lsun/A)
c       inw  : number of wavelength points
c       nf   : number of photometric bands (filters)
c       ifilt: array containing the indexes of the filters in response file
c       mags : magnitudes
c	WAVE_FILT,TRANS_FILT,AREA_FILT,FILT_LENGTH : arrays for EAZY filters
c       ---------------------------------------------------------------------------
        implicit none
        integer nf
        integer i,inw,icall,iread,jread,ireset
	integer ifilt(50)
	real*8 x(inw),ys(inw),y0s(inw)
	real z,f_mean,dl,mag(nf),fx(nf)
	data icall/0/
	character filtfile*80
	
	integer J

	! parameters for EAZY filters
        integer nmax_eazy
	parameter(nmax_eazy=500)
        real WAVE_FILT(10000,nmax_eazy)
        real TRANS_FILT(10000,nmax_eazy)
        real AREA_FILT(nmax_eazy)
        integer FILT_LENGTH(nmax_eazy)
	
	real f_mean_eazy


	if (icall.eq.0) then
		icall=1
	endif

c	Compute flux through each of nb filters
        J=0
        do i=1,nf

	   if(ifilt(i).gt.1e4)then	! custom filters in EAZY format
		   
		   J=J+1	
		   fx(i)=f_mean_eazy(ifilt(i),J,sngl(x),sngl(ys),inw,z,
     +		   WAVE_FILT(1:FILT_LENGTH(J),J),
     +		   TRANS_FILT(1:FILT_LENGTH(J),J),
     +		   AREA_FILT(J),FILT_LENGTH(J))
			
			!write(*,*)ifilt(i),J,fx(i)
	   
	   else				! original MAGPHYS filters

		   fx(i)=f_mean(ifilt(i),sngl(x),sngl(ys),inw,z,filtfile)
           
	   end if

	   !write(*,*) fx(i)
	
	enddo

c       Compute absolute (k-shifted) AB magnitude
c       10 pc in units of Mpc
        dl=1.e-5
	do i=1,nf
	   mag(i)=-2.5*alog10(fx(i))-48.6
	   mag(i)=mag(i)+(5.*alog10(1.7684e+08*dl)) ![this factor is SQRT(4*pi*(3.0856E24)^2/Lsun)]
	enddo

        return
	end

c       ===========================================================================
	SUBROUTINE FILTER0(filtfile)
c       ===========================================================================
c	Reads filter response functions from (binary) file FILTERBIN.RES
c       ---------------------------------------------------------------------------
	INCLUDE 'filter.dec'
	character filtfile*80
	close (81)

c	Get file name and path from environment variable FILTERS
	!call getenv('FILTERS',filtfile)
	open (81,file=filtfile,form='unformatted',status='old')

	l=largo(filtfile)
	write (6,'(/x,2a)') 'Reading Filter File: ',filtfile(1:l)
	read (81,err=1) nf,(ni(i),i=1,nf),(nl(i),i=1,nf),(np(i),i=1,nf),
     +	(fid(i),i=0,nf),ltot,(r(i,1),i=1,ltot),(r(i,2),i=1,ltot)
	close (81)
	iread=1
	write (6,'(i4,a,i3,a,$)') nf,' filters defined, out of ',mxft,' maximum'
	write (6,'(x,a)') '    ...done'
	return
1	stop 'Program exits because of error reading file FILTERBIN.RES'
	end



c       ===========================================================================
	SUBROUTINE READ_FILTERS_EAZY(NFILT,ID_FILTER,WAVE_FILT,
     2	TRANS_FILT,AREA_FILT,FILT_LENGTH,eazy_filt_info,eazy_filt)
c       ===========================================================================
c	Reads filter response functions from EAZY file once fo all.
c       ---------------------------------------------------------------------------

	! NFILT 	= (input) number of filters to be used
	! ID_FILTER	= (input) array containing filter IDs of filters to be used (EAZY ID + 1e4)
	! WAVE_FILT	= (output) [A] matrix containing wavelength of all filters to be used
	! TRANS_FILT	= (output) matrix containing transmission curves of all filters to be used 
	! AREA_FILT	= (output) array containing areas of filters to be used
	! FILT_LENGTH	= (output) array containing lengths of filters to be used


        integer nmax_eazy
	parameter(nmax_eazy=500)

	character eazy_filt_info*80,eazy_filt*80

	integer ID_FILT_EAZY(nmax_eazy)
	real WAVE_FILT(10000,nmax_eazy)
	real TRANS_FILT(10000,nmax_eazy)
	real AREA_FILT(nmax_eazy)


	INTEGER NFILT					! number of usable filters
	
	!INTEGER ID_FILTER(NFILT)			! ID of filters TO BE USED in EAZY file
	!INTEGER FILT_LINE(NFILT)			! starting line of filter in EAZY file
	!INTEGER FILT_LENGTH(NFILT)			! length of filter in EAZY file

	INTEGER ID_FILTER(nmax_eazy)			! ID of filters TO BE USED in EAZY file
	INTEGER FILT_LINE(nmax_eazy)			! starting line of filter in EAZY file
	INTEGER FILT_LENGTH(nmax_eazy)			! length of filter in EAZY file
	
	INTEGER I, J
	INTEGER IDUMMY
	REAL DUMMY
	
	REAL DUMMY_ARRAY1(nmax_eazy), DUMMY_ARRAY2(nmax_eazy)
	
	REAL TRAPZ1
	
	
	ID_FILTER=ID_FILTER-1e4		! I had added 1e4 to filters IDs in order to recognize those 
					! to be read from the EAZY file instead than from the MAGPHYS file.

	if(nfilt.gt.nmax_eazy)then 
		write(*,*) 'Too many EAZY filters requested (max=500).'
		write(*,*) 'You need to edit code!'
		write(*,*) 'Aborting!'
		STOP
	end if



	! Read information of all filters, from the EAZY .info file

	OPEN(3, FILE=eazy_filt_info, STATUS='OLD', RECL=3000, ERR=26)
	
	! skip header -> there's no header to skip in this file!
	!READ(3,*)

	IDUMMY=0
	DO WHILE(.TRUE.)
		READ(3,*,END=16)
		IDUMMY=IDUMMY+1
		CYCLE			! record found, go for a new one
16			CONTINUE	! end of file reached
			EXIT		! jump out of the loop
	END DO


	REWIND(3)

	DO I= 1, IDUMMY
		READ(3,*) DUMMY, DUMMY_ARRAY1(I),DUMMY_ARRAY2(I)
	END DO

	CLOSE(3)




	! now select line number and length of the filters to be used only

	DO I=1,NFILT
		FILT_LINE(I)=DUMMY_ARRAY1(ID_FILTER(I))
		FILT_LENGTH(I)=DUMMY_ARRAY2(ID_FILTER(I))
	END DO




	! now effectively read filters to be used
	
	DO I=1,MAXVAL(FILT_LENGTH(:))
		WAVE_FILT(I,:)=0.0
		TRANS_FILT(I,:)=0.0
	END DO
	
	OPEN(3, FILE=eazy_filt, STATUS='OLD', RECL=3000, ERR=27)

	
	DO I=1,NFILT
		
		! skip previous filters
		DO J=1,FILT_LINE(I)
			READ(3,*)
		END DO
		
		DO J=1,FILT_LENGTH(I)
			READ(3,*) DUMMY, WAVE_FILT(J,I),TRANS_FILT(J,I)
		END DO
		
		REWIND(3)
	
	END DO

	CLOSE(3)

	! note that the filter wavelengths are defined in Angstroms!!!!!!!!
	! (see EAZY file .RES)


	! finally derive area of each filter, i.e. INTEGRAL(transmission(lambda) d-lambda)


	DO I=1,NFILT

	   AREA_FILT(I)=TRAPZ1(WAVE_FILT(1:FILT_LENGTH(I),I),
     2	   TRANS_FILT(1:FILT_LENGTH(I),I),FILT_LENGTH(I))		! [A]  !!!!!!!!!! 

	END DO



	RETURN
	

26	WRITE(*,*) 'ERROR! INPUT file ',eazy_filt_info,' not found!'
	WRITE(*,*) 'ABORTING!'
	STOP

27	WRITE(*,*) 'ERROR! INPUT file ',eazy_filt,' not found!'
	WRITE(*,*) 'ABORTING!'
	STOP


	END



c       ===========================================================================
        FUNCTION F_MEAN(I,X,Y,N,Z,filtfile)	
c       ===========================================================================
c       Returns mean flux >>> (Fnu) <<< in ith filter (/Hz)
c       As: f_nu=int(dnu Fnu Rnu/h*nu)/int(dnu Rnu/h*nu)
c       ie: f_nu=int(dlm Flm Rlm lm / c)/int(dlm Rlm/lm)

c	The s.e.d. is Y(X) with N data points. Z is the redshift
c	to be applied to the s.e.d.

c	Improved version that samples correctly the s.e.d. and the
c	filter response function at all points available in these arrays.

c       The new version of the F_MEAN routine requires the filter
c	response function to be interpolated at each point in the
c	sed which is not a point in the filter response. All points in
c	the filter response are also used. The format of the binary
c	file was changed to reduce its size. Filters are stored
c	sequentially in r(i,k), k=1 => wavelength, k=2 => response
c	function. Information about starting point and number of
c	points per filter is kept in file, as well as filter id label.

c       i    : index of the filter
c       x    : wavelength vector (in A)
c       y    : SED L_lambda (in Lsun/A)
c       n    : number of wavelength points
c       z    : redshift
c       ---------------------------------------------------------------------------
	INCLUDE 'filter.dec'
	integer pos_i(mxft),pos_f(mxft),ifilt(mxft),ierr(mxft)
	real x(n),y(n),LINEAR
	real xlam(100000),rlam(100000),xf(8000),rf(8000),rfa(8000),rfb(8000)
	real rfc(8000),rfd(8000)
	common /save_filter_2/ nfilt,ntot,pos_i,pos_f,ifilt,xlam,rlam
	data ierr/mxft*0/,zzlast/-100./
	real xeff(mxft)
	save xeff
	character filtfile*80

	f_mean=0.
c	Check filter number
	if (i.gt.mxft) then
		write (6,*) 'Filter No.',i,' not available.'
		return
	elseif (i.le.0) then
c       [Introduced to allow computation of K-correction with routine ~/is/k_correct.f]
		f_mean=1.
		return
	endif

c	Read filter file
	if (iread.eq.0) Call FILTER0(filtfile)

c	Check z value
	if (z.ne.zzlast.or.ireset.gt.0) then
		ireset=0
		zzlast=z
		nfilt=0
		ntot=0
		pos_i(1)=1
		do k=1,mxft
		ifilt(k)=-10
		enddo
	endif

c	Extract filter
c	Check if filter has been stored already
	z1=1.+z

	do k=1,nfilt
	if (ifilt(k).eq.i) goto 2
	enddo

c	Extract ith-filter. Shift by (1+z)
	m=0
	do k=ni(i),nl(i)
	m=m+1
	xf(m)=r(k,1)/z1
	rf(m)=r(k,2)

	rfc(m)=rf(m)*xf(m)
	rfd(m)=rf(m)	

	enddo

c       Effective wavelength of the filter:
	xeff(i)=z1*TRAPZ1(xf,rfc,m)/TRAPZ1(xf,rfd,m)

c	Add wavelength points in the sed.
	l=0
	do k=1,n
	xz=x(k)/z1
	if (xz.ge.xf(np(i))) then
		goto 1
	elseif (xz.gt.xf(1)) then
		m=m+1
		xf(m)=xz
c		Interpolate shifted filter at shifted wavelength of sed
		rf(m)=LINEAR(xz,xf,rf,np(i),l)
	endif
	enddo

c	Sort (xf,rf) arrays according to xf
1	call sort2(m,xf,rf)

c	Store sorted arrays
	do k=1,m
	ntot=ntot+1
	xlam(ntot)=xf(k)
	rlam(ntot)=rf(k)
	enddo

c	Store filter No. and ending point in sorted arrays
	nfilt=nfilt+1
	ifilt(nfilt)=i
	pos_f(nfilt)=ntot
	pos_i(nfilt+1)=ntot+1
	k=nfilt
	kt=pos_f(k)-pos_i(k)+1
	write(6,'(a,i2,a,i4,a,a)')'#',nfilt,', ID:',i,' -- ',(fid(i)(1:60))
	write(*,'(a,f10.4,a)') 'lambda_eff= ', xeff(i)*1.e-4, ' microns'

c	Use kth filter in extracted filter array
c	Interpolate sed at shifted wavelength of filter
2	m=0
	l=0
	do j=pos_i(k),pos_f(k)
	m=m+1
c	take wavelength in detector frame
	xf(m)=xlam(j)*z1
	rfa(m)=rlam(j)*xf(m)*LINEAR(xlam(j),x,y,n,l)
	rfb(m)=rlam(j)/xf(m)
	enddo
	
c	Compute flux below filter.
	f_mean=TRAPZ1(xf,rfa,m)/TRAPZ1(xf,rfb,m)
	f_mean=f_mean/2.997925e+18
c	F(lambda)*dlambda = F[lambda/(1+z)]*dlambda/(1+z)
	f_mean=f_mean/z1

	return
	end




c       ===========================================================================
        FUNCTION F_MEAN_EAZY(I,INDX_FILT_EAZY,X,Y,N,Z,
     +	WAVE_FILT,TRANS_FILT,AREA_FILT,FILT_LENGTH)	
c       ===========================================================================
c       Returns mean flux >>> (Fnu) <<< in ith filter (/Hz)
c       As: f_nu=int(dnu Fnu Rnu/h*nu)/int(dnu Rnu/h*nu)
c       ie: f_nu=int(dlm Flm Rlm lm / c)/int(dlm Rlm/lm)

c	The s.e.d. is Y(X) with N data points. Z is the redshift
c	to be applied to the s.e.d.

!	new version using filters in EZY format, instead of filters from 
!	the original MAGPHYS binary file

c       i    : id of the filter (which is ID in EAZY file + 1e4)
C	INDX_FILT_EAZY    : index of the EAZY filter in the list of EAZY filters to be used
c       x    : wavelength vector (in A) [of the SED]
c       y    : SED L_lambda (in Lsun/A)
c       n    : number of wavelength points
c       z    : redshift
c	WAVE_FILT : wavelength array of EAZY filters (to be used)
c	TRANS_FILT : transmission array of EAZY filters (to be used) 
c	AREA_FILT : area of given EAZY filter
c	FILT_LENGTH : length of given EAZY filter
c       ---------------------------------------------------------------------------



	
	INCLUDE 'filter.dec'		! other variables
	integer pos_i(mxft),pos_f(mxft),ifilt(mxft),ierr(mxft)
	real x(n),y(n),LINEAR
	real xlam(100000),rlam(100000),xf(8000),rf(8000),rfa(8000),rfb(8000)
	real rfc(8000),rfd(8000)
	common /save_filter_2/ nfilt,ntot,pos_i,pos_f,ifilt,xlam,rlam
	data ierr/mxft*0/,zzlast/-100./
	real xeff(mxft)
	save xeff
	
        integer nmax_eazy
        parameter(nmax_eazy=500)
        integer INDX_FILT_EAZY
        integer FILT_LENGTH
        real WAVE_FILT(FILT_LENGTH)
        real TRANS_FILT(FILT_LENGTH)
        real AREA_FILT
	real y_interp(FILT_LENGTH)
	
	real dummy1, dummy2
	
	f_mean_eazy=0.
	

	


	! interpolate SED onto filter (redshifted) array
	
	l=0
	do k=1,FILT_LENGTH
	  
!	  CALL POIN(x,y,n,						! SED wavelength is in [A], SED luminosity is in [Lsun/A]
!     2	  2,								! interpolation order
!     2	  WAVE_FILT(k,INDX_FILT_EAZY)/(1.+z),				! de-redshift filter wavelength [A]
!     2	  DUMMY1,DUMMY2)						! dummy1=interpolated luminosity ; dummy2="error"
!
!	  y_interp(k)=dummy1 
	
	  y_interp(k)=LINEAR(WAVE_FILT(k)/(1.+z),x,y,n,l)			! [Lsun/A]

	  !write(*,*) '---'
	  !write(*,*)y_interp(k)


	  y_interp(k)=y_interp(k)*(WAVE_FILT(k)/(1.+z))**2/			! [Lsun/Hz]
     2	  2.997925e+18*(1.+z)  

	
	  !write(*,*)y_interp(k)
	  !write(*,*) '---'
	
	end do


	
c	Compute flux below filter.
	f_mean_eazy=TRAPZ1(WAVE_FILT/(1.+z),y_interp*TRANS_FILT,
     2	FILT_LENGTH)/(AREA_FILT/(1.+Z))
     


	return
	end




c       ===========================================================================
	SUBROUTINE NREAD(X,NA,*,*)
c       ===========================================================================
c	This routine is useful when reading several parameters separated by
c	commas (not supported by current version of f77 in Sun 4/110).

c	Returns NA arguments in array X (read from the screen).
c	RETURN 1: Statement to execute if error while reading.
c	RETURN 2: Statement to execute if EOF detected.
c       ---------------------------------------------------------------------------
	parameter (npar=24)
	character b*132
	real x(npar)

c	Clear buffer
	do i=1,npar
	x(i)=0.
	enddo

c	Read string b
	read (5,'(a)',end=2) b

c	Number of characters read into b
c	na=index(b,' ')-1
	na=largo(b)
	if (na.eq.0) return

c	Adds "," at the end of string b to guarantee extraction of last value
	b(na+1:na+1)=','

c	Extract numbers from b
	n=0
	l1=0
	do i=1,100
	l1=l1+n+1
	n=index(b(l1:),',')-1
	if (n.eq.0) then
		x(i)=0.
	elseif (n.gt.0) then
      		read(b(l1:l1+n-1),'(G132.0)',err=1) x(i)
	else
		na=i-1
		return
	endif
	enddo
1	return 1
2	return 2

	ENTRY QREAD(V,K,*,*)

c	Emulates q format of VMS/Fortran

c	V = required value
c	K = number of characters typed
c	RETURN 1: Statement to execute if error while reading.
c	RETURN 2: Statement to execute if EOF detected.

c	Read string b and assign value to v
	read (5,'(a)',end=4) b
c	k = index(b,' ') - 1
	k=largo(b)
	v=0.
	if (k.gt.0) then
      		read(b(:k),'(G132.0)',err=3) v
	endif
	return
3	return 1
4	return 2
	end


c       ===========================================================================
	REAL*4 FUNCTION COSMOL_C(h,omega,omega_lambda,q)
c       ===========================================================================
c	Returns cosmological constant = cosmol_c and parameter q

c       Omega is entered by the user
c       omega=1.-omega_lambda
c       ---------------------------------------------------------------------------

c       Cosmological constant
        cosmol_c=omega_lambda/(3.*h**2)

c       Compute q=q0
        if (omega_lambda.eq.0.) then
                q=omega/2.
        else
                q=(3.*omega/2.) - 1.
        endif
	return
	end

c       ===========================================================================
        REAL*4 FUNCTION T(h, q, z, lamb)
c       ===========================================================================
c	Returns age of the Universe at redshift z
c       for the specified cosmological parameters
c       ---------------------------------------------------------------------------
	implicit none
	real*4 h, q, z, a, b, c, hh0, cosh, x, lamb
	real*4 aa, bb, epsr, s0, s, funq, omega0
	integer npts
	logical success
	external funq
	common /cosm/ omega0

c	H = Ho in km/sec/Mpc
c	Q = qo  (if problems with qo = 0, try 0.0001)

	a(q,z) = (sqrt(1. + ((2. * q) * z)) / (1. - (2. * q))) / (1. + z)
	b(q) = q / (abs((2. * q) - 1.) ** 1.5)
	c(q,z) = ((1. - (q * (1. - z))) / q) / (1. + z)

	cosh(x) = alog(x + sqrt((x ** 2) - 1.))
	hh0 = h * 0.001022
c       in (billion years)**(-1)

	if (lamb .ne. 0.0) then
         	omega0 = (2. * (q + 1.)) / 3.
         	aa = 0.
         	bb = 1. / (1. + z)
	        success=.false.
		s0=1.e-10
		npts=0
		do while (.not.success)
		  npts=npts+1
		  callmidpnt(funq,aa,bb,s,npts)
		  epsr=abs(s-s0)/s0
		  if (epsr.lt.1.e-4) then
			success=.true.
		  else
			s0=s
		  endif
		enddo
		t=s
	     else if (q .eq. 0.0) then
		t = 1. / (1. + z)
	else if (q .lt. 0.5) then
	   t = a(q,z) - (b(q) * cosh(c(q,z)))
	else if (q .eq. 0.5) then
	   t = (2. / 3.) / ((1. + z) ** 1.5)
	else
	   t = a(q,z) + (b(q) * cos(c(q,z)))
	end if

	t = t / hh0

	return
	end


c       ===========================================================================
        REAL*4 FUNCTION FUNQ(x)
c       ===========================================================================
c       for non-zero cosmological constant
c       ---------------------------------------------------------------------------
	real*4 x, omega0, omegainv
	common /cosm/ omega0
	omegainv = 1. / omega0
	funq = sqrt(omegainv) / (x*sqrt((omegainv-1.)+(1./(x**3.))))
	return
	end


c       ===========================================================================
	FUNCTION DISMOD(H0,Q0,Z)
c       ===========================================================================
c	Returns cosmological distance modulus
c       ---------------------------------------------------------------------------
c	H0 = Ho in km/sec/Mpc
c	Q0 = qo
c	DL = Luminosity distance in Mpc

	dismod = 5*alog10(dl(h0,q0,z)*1.E6/10.)

	return
	end


c       ===========================================================================
	REAL*4 FUNCTION DL(h,q,z)
c       ===========================================================================
c	Computes luminosity distance corresponding to a redshift z.
c	Uses Mattig formulae for qo both 0 and non 0
c	Revised January 1991 to implement cosmolgical constant
c	Ho in km/sec/Mpc, DL is in Mpc
c       ---------------------------------------------------------------------------
	implicit none
	real*4 h, q, z, d1, d2
	real*4 aa, bb, epsr, s, s0, funl
	real*4 dd1, dd2, omega0
	logical success
	integer npts
	external funl
	common /cosm/ omega0

	if (z.le.0.) then
	   dl=1.e-5		!10pc
	   return
	endif

	if (q .eq. 0) then
	   dl = ((3.e5 * z) * (1 + (z / 2.))) / h
	else if (q .gt. 0.) then
	   d1 = (q * z) + ((q - 1.) * (sqrt(1. + ((2. * q) * z)) - 1.))
	   d2 = ((h * q) * q) / 3.e5
	   dl = d1 / d2
	else if (q .lt. 0.) then
	   omega0 = (2. * (q + 1.)) / 3.
	   aa = 1.
	   bb = 1. + z
	   success=.false.
	   s0=1.e-10
	   npts=0
	   do while (.not.success)
	      npts=npts+1
	      call midpnt(funl,aa,bb,s,npts)
	      epsr=abs(s-s0)/s0
	      if (epsr.lt.1.e-4) then
		 success=.true.
	      else
		 s0=s
	      endif
	   enddo
	   dd1=s
	   dd2 = (3.e5 * (1. + z)) / (h * sqrt(omega0))
	   dl = dd1 * dd2
	end if

      return
      end


c       ===========================================================================
	REAL*4 FUNCTION FUNL(x)
c       ===========================================================================
c       For non-zero cosmological constant
c       ---------------------------------------------------------------------------
	real*4 x, omega0, omegainv
	common /cosm/ omega0
	omegainv = 1. / omega0
	funl = 1. / sqrt(((x ** 3.) + omegainv) - 1.)
	return
	end


c       ===========================================================================
	FUNCTION LARGO(A)
c       ===========================================================================
c	Returns significant length of string a
c       ---------------------------------------------------------------------------
	character*(*) a
	largo=0
	do i=1,len(a)
	if (a(i:i).ne.' ') largo=i
	enddo
	return
	end


c       ===========================================================================
	REAL FUNCTION LINEAR (X0,X,Y,N,I0)
c       ===========================================================================
c	Interpolates linearly the function y(x) at x=x0
c       ---------------------------------------------------------------------------
	REAL X(N),Y(N)
	data ierr/0/
	IF (I0) 21,20,20
 20	I=IPLACE(X0,X,MAX0(1,I0),N)
	GOTO 22
 21	I=-I0
 22	I0=I
	IF (I.EQ.0) GOTO 2
	IF (X0.EQ.X(I).OR.X(I).EQ.X(I+1)) GOTO 1
	LINEAR=Y(I) + (Y(I+1)-Y(I))*(X0-X(I))/(X(I+1)-X(I))
	RETURN
 1	LINEAR=Y(I)
	RETURN
 2	if (ierr.eq.0) then
	   ierr=1
	   write (6,3) X0
	   write (6,*) 'Error reported only once. It may occur more than once.'
	endif
 3	FORMAT (' --- LINEAR:  X0 = ',1PE10.3,' is outside X range ---')
	LINEAR=0.
	RETURN
	END


c       ===========================================================================
	SUBROUTINE SORT2(N,RA,RB)
c       ===========================================================================
c	Sorts array ra(n)
c       ---------------------------------------------------------------------------      
	DIMENSION RA(N),RB(N)
	L=N/2+1
	IR=N
 10	CONTINUE
        IF(L.GT.1)THEN
	   L=L-1
	   RRA=RA(L)
	   RRB=RB(L)
        ELSE
	   RRA=RA(IR)
	   RRB=RB(IR)
	   RA(IR)=RA(1)
	   RB(IR)=RB(1)
	   IR=IR-1
	   IF(IR.EQ.1)THEN
	      RA(1)=RRA
	      RB(1)=RRB
	      RETURN
	   ENDIF
        ENDIF
        I=L
        J=L+L
 20	IF(J.LE.IR)THEN
	   IF(J.LT.IR)THEN
	      IF(RA(J).LT.RA(J+1))J=J+1
	   ENDIF
	   IF(RRA.LT.RA(J))THEN
	      RA(I)=RA(J)
	      RB(I)=RB(J)
	      I=J
	      J=J+J
	   ELSE
	      J=IR+1
	   ENDIF
	   GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
	GO TO 10
	END

c       ===========================================================================
	SUBROUTINE MIDPNT(func,a,b,s,n)
c       ===========================================================================
	INTEGER n
	REAL a,b,s,func
	EXTERNAL func
	INTEGER it,j
	REAL ddel,del,sum,tnm,x
	if (n.eq.1) then
	   s=(b-a)*func(0.5*(a+b))
	else
	   it=3**(n-2)
	   tnm=it
	   del=(b-a)/(3.*tnm)
	   ddel=del+del
	   x=a+0.5*del
	   sum=0.
	   do 11 j=1,it
	      sum=sum+func(x)
	      x=x+ddel
	      sum=sum+func(x)
	      x=x+del
 11	   continue
	   s=(s+(b-a)*sum/tnm)/3.
	endif
	return
	END


c       ===========================================================================
	FUNCTION TRAPZ1 (X,Y,N)
c       ===========================================================================
c	Integrates function y(x)
c       n : number of points
c       ---------------------------------------------------------------------------  
	REAL X(N),Y(N)
	TRAPZ1=0.
	IF (N.LE.1) RETURN
	DO 1 J=2,N
 1	   TRAPZ1= TRAPZ1 + ABS(X(J)-X(J-1))*(Y(J)+Y(J-1))/2.
	   RETURN
 2	   TRAPZ1=Y(1)*X(1)/2.
	   RETURN
	   END


c       ===========================================================================
	INTEGER FUNCTION IPLACE(X0,XX,N1,N2)
c       ===========================================================================
c	Finds L such that XX(L).lt.X0.lt.XX(L+1)
c       n1 : start point
c       n2 : end point
c       ---------------------------------------------------------------------------  
	DIMENSION XX(N2)
	X(I)=XX(N1+I-1)
	N=N2-N1+1
	I=1
	IF (X(1).GT.X(2)) I=2
	L=0
 1	L=L+1
	IF (L.EQ.N) GOTO 4
	GOTO (2,3),I
 2	IF (X(L).LE.X0.AND.X0.LT.X(L+1)) GOTO 5
	GOTO 1
 3	IF (X(L).GE.X0.AND.X0.GT.X(L+1)) GOTO 5
	GOTO 1
 4	IF (X0.NE.X(N)) GOTO 6
 5	IPLACE=L+N1-1
	RETURN
 6	IPLACE=0
	RETURN
	END


***********************************************************	

c       ===========================================================================
	REAL*8 FUNCTION TRAPZ8 (X,Y,N)
c       ===========================================================================
c	Integrates function y(x)
c       n : number of points
c       ---------------------------------------------------------------------------  
	REAL*8 X(N),Y(N)
	integer N,J
	TRAPZ8=0.
	IF (N.LE.1) RETURN
	DO 1 J=2,N
 1	   TRAPZ8= TRAPZ8 + DABS(X(J)-X(J-1))*(Y(J)+Y(J-1))/2.
	   RETURN
 2	   TRAPZ8=Y(1)*X(1)/2.
	   RETURN
	   END
