

c     ===========================================================================
      PROGRAM FIT_SED_TORUS
c     ---------------------------------------------------------------------------

!	Last Version: Stefano Berta, February 5th, 2016





      implicit none
      integer isave,i,j,k,i_gal,io,largo
      integer nmax,galmax,nmod
      parameter(nmax=70,galmax=20000) !nmax: maxium number of photometric points/filters
      integer n_obs,n_models,ibin  !galmax: maximum number of galaxies in one input file
      integer kfilt_sfh(nmax),kfilt_ir(nmax),nfilt_sfh,nfilt_ir,nfilt_mix
      integer nprop_sfh,nprop_ir
      integer n_sfh,n_ir,i_ir,i_sfh,ir_sav,sfh_sav
      integer nfilt,filt_id(nmax),fit(nmax),ifilt
      parameter(nmod=50001,nprop_sfh=24,nprop_ir=8)
      character*12 filt_name(nmax)
      character*20 outfile1,outfile2
      character*2500 filter_header
      character*8 gal_name(galmax),aux_name
      character*6 numz
      character optlib*50,irlib*50
      character filters*80,obs*80
c     redshift libs
      integer nz,nzmax
      parameter(nzmax=20000)
      real*8 zlib(nzmax) 
      real diffz(nzmax)		
c     observations, filters, etc.
      real*8 w(galmax,nmax),redshift(galmax),dist(galmax)
      real*8 flux_obs(galmax,nmax),sigma(galmax,nmax),aux
      real*8 flux_sfh(nmod,nmax)
      real*8 ssfr6(nmod),ssfr7(nmod),ssfr8(nmod)
      real*8 lambda_eff(nmax),lambda_rest(nmax)
c     model libraries, parameters, etc.
      integer n_flux,indx(nmod)
      real*8 fprop_sfh(nmod,nprop_sfh),fmu_sfh(nmod)
      real*8 fprop_ir(nmod,nprop_ir),fmu_ir(nmod)
      real*8 ldust(nmod),mstr1(nmod),logldust(nmod)
      real*8 lssfr6(nmod),lssfr7(nmod),lssfr8(nmod)
      real*8 flux_ir(nmod,nmax),tvism(nmod),tauv(nmod),mu(nmod)
      real*8 tbg1(nmod),tbg2(nmod),xi1(nmod),xi2(nmod),xi3(nmod)
      real*8 fmu_ism(nmod),mdust(nmod),lmdust(nmod)
      real*8 tform(nmod),age_wm(nmod),age_wr(nmod)
      real*8 ltform(nmod),lage_wm(nmod),lage_wr(nmod)		
c     chi2, scaling factors, etc.
      real*8 flux_mod(nmax)
      real*8 chi2,chi2_sav,chi2_new,df
      real*8 a,num,den,a_sav,chi2_nd
      real*8 ptot,prob,chi2_new_opt,chi2_new_ir
      real*8 chi2_opt,chi2_ir,chi2_sav_opt,chi2_sav_ir
c     histograms
      real*8 fmu_min,fmu_max,dfmu
      real*8 ssfr_min,ssfr_max,dssfr		
      real*8 age_min,age_max,dage		
      real*8 fmuism_min,fmuism_max,dfmu_ism
      real*8 mu_min,mu_max,dmu
      real*8 tv_min,tv_max,dtv,dtvism
      real*8 sfr_min,sfr_max,dsfr
      real*8 a_min,a_max,da
      real*8 md_min,md_max,dmd
      real*8 ld_min,ld_max,dldust
      real*8 tbg1_min,tbg1_max,dtbg,tbg2_min,tbg2_max
      real*8 xi_min,xi_max,dxi
      real*8 pct_sfr6(5),pct_sfr7(5),pct_sfr8(5)
      real*8 pct_fmu_sfh(5),pct_fmu_ir(5)
      real*8 pct_mu(5),pct_tv(5),pct_mstr(5)
      real*8 pct_ssfr6(5),pct_ssfr7(5),pct_ssfr8(5)
      real*8 pct_age_wm(5),pct_age_wr(5),pct_tform(5)
      real*8 pct_ld(5),pct_tbg2(5)
      real*8 pct_tbg1(5),pct_xi1(5),pct_xi2(5)
      real*8 pct_xi3(5),pct_tvism(5),pct_ism(5),pct_md(5)
      integer nbinmax1,nbinmax2
      parameter (nbinmax1=20001,nbinmax2=5001)	
      real*8 psfh2(nbinmax2),pir2(nbinmax2),pmu2(nbinmax2)
      real*8 ptv2(nbinmax2),pxi2_2(nbinmax2)
      real*8 pssfr62(nbinmax2),pssfr72(nbinmax2),pssfr82(nbinmax2)
      real*8 page_wm2(nbinmax2),page_wr2(nbinmax2),ptform2(nbinmax2)
      real*8 pa2(nbinmax2),pldust2(nbinmax2)
      real*8 ptbg1_2(nbinmax2),ptbg2_2(nbinmax2),pxi1_2(nbinmax2)
      real*8 ptvism2(nbinmax2),pism2(nbinmax2),pxi3_2(nbinmax2)
      real*8 fmuism2_hist(nbinmax2),md2_hist(nbinmax2)
      real*8 ssfr2_hist(nbinmax2),pmd_2(nbinmax2)
      real*8 age2_hist(nbinmax2)
      real*8 psfr62(nbinmax2),psfr72(nbinmax2),psfr82(nbinmax2)
      real*8 fmu2_hist(nbinmax2),mu2_hist(nbinmax2),tv2_hist(nbinmax2)
      real*8 sfr2_hist(nbinmax2),a2_hist(nbinmax2),ld2_hist(nbinmax2)
      real*8 tbg1_2_hist(nbinmax2),tbg2_2_hist(nbinmax2),xi2_hist(nbinmax2)
      real*8 tvism2_hist(nbinmax2)
      integer nbin_fmu,nbin_mu,nbin_tv,nbin_a,nbin2_tvism
      integer nbin_tbg1,nbin_tbg2,nbin_xi,nbin_sfr,nbin_ld
      integer nbin2_fmu,nbin2_mu,nbin2_tv,nbin2_a,nbin_fmu_ism
      integer nbin2_fmu_ism,nbin_md,nbin2_md,nbin_ssfr,nbin2_ssfr
      integer nbin_age,nbin2_age
      integer nbin2_tbg1,nbin2_tbg2,nbin2_xi,nbin2_sfr,nbin2_ld
      real*8 fmu_hist(nbinmax1),psfh(nbinmax1),pism(nbinmax1)
      real*8 pir(nbinmax1),ptbg1(nbinmax1)
      real*8 mu_hist(nbinmax1),pmu(nbinmax1),ptbg2(nbinmax1)
      real*8 tv_hist(nbinmax1),ptv(nbinmax1),ptvism(nbinmax1)
      real*8 sfr_hist(nbinmax1),fmuism_hist(nbinmax1)
      real*8 psfr6(nbinmax1),psfr7(nbinmax1),psfr8(nbinmax1)
      real*8 pssfr6(nbinmax1),pssfr7(nbinmax1),pssfr8(nbinmax1)
      real*8 page_wm(nbinmax1),page_wr(nbinmax1),ptform(nbinmax1)
      real*8 a_hist(nbinmax1),pa(nbinmax1)
      real*8 ld_hist(nbinmax1),pldust(nbinmax1)
      real*8 tbg1_hist(nbinmax1),tbg2_hist(nbinmax1)
      real*8 ssfr_hist(nbinmax1),xi_hist(nbinmax1),pxi1(nbinmax1)
      real*8 age_hist(nbinmax1)
      real*8 pxi2(nbinmax1),pxi3(nbinmax1)
      real*8 md_hist(nbinmax1),pmd(nbinmax1)
      real*8 i_fmu_sfh(nmod),i_fmu_ir(nmod)
      real*8 i_mu(nmod),i_tauv(nmod),i_tvism(nmod)
      real*8 i_lssfr6(nmod),i_lssfr7(nmod),i_lssfr8(nmod),i_fmu_ism(nmod)
      real*8 i_lage_wm(nmod),i_lage_wr(nmod),i_ltform(nmod)
      real*8 i_tbg1(nmod),i_xi1(nmod),i_xi2(nmod),i_xi3(nmod)
      real*8 i_tbg2(nmod)
c     cosmological parameters
      real*8 h,omega,omega_lambda,clambda,q
      real*8 cosmol_c,dl  
c     histogram parameters: min,max,bin width
      data fmu_min/0./,fmu_max/1.0005/,dfmu/0.001/
      data fmuism_min/0./,fmuism_max/1.0005/,dfmu_ism/0.001/       
      data mu_min/0./,mu_max/1.0005/,dmu/0.001/
      data tv_min/0./,tv_max/6.0025/,dtv/0.005/
      data age_min/7.05/,age_max/10.15/,dage/0.05/		
      data ssfr_min/-13./,ssfr_max/-5.9975/,dssfr/0.05/
      data sfr_min/-3./,sfr_max/3.5005/,dsfr/0.005/
      data a_min/7./,a_max/13.5025/,da/0.005/		
      data ld_min/7./,ld_max/13.0025/,dldust/0.005/
      data tbg1_min/30./,tbg1_max/60.0125/,dtbg/0.025/
      data tbg2_min/15./,tbg2_max/25.0125/
      data xi_min/0./,xi_max/1.0001/,dxi/0.001/
      data md_min/3./,md_max/9./,dmd/0.005/
c     cosmology
      data h/70./,omega/0.30/,omega_lambda/0.70/
      data isave/0/
c     save parameters
      save flux_ir,flux_sfh,fmu_ir,fmu_sfh
      save mstr1,ssfr6,ssfr7,ssfr8,ldust,mu,tauv,fmu_ism
      save lssfr6,lssfr7,lssfr8,logldust,tvism
      save lage_wm,lage_wr,ltform
      save tbg1,tbg2,xi1,xi2,xi3
      save flux_obs,sigma,dist
      save mdust
      
      
      ! added by Stefano Berta
      ! -----------------------
      
      real*8 pigrec
      integer i_ste, j_ste, k_ste, m_ste, n_ste	
      
      character toruslib*50		
      integer i_torus			
      integer ntorus			

      parameter(ntorus=22000)		
 
      integer torus_id(ntorus)		
      integer tot_torus			
      integer dummy_do_torus
      real*8 torus_rm(ntorus)		
      real*8 torus_ct(ntorus)		
      real*8 torus_ta(ntorus)		
      real*8 torus_be(ntorus)		
      real*8 torus_al(ntorus)		
      real*8 torus_plw(ntorus)		
      real*8 torus_phi(ntorus)		
      real*8 flux_torus(ntorus,nmax)	
      real*8 tau_los(ntorus)		
      
      real*8 torus_rm_min,torus_rm_max,dtorus_rm		
      real*8 torus_ct_min,torus_ct_max,dtorus_ct
      real*8 torus_ta_min,torus_ta_max,dtorus_ta
      real*8 torus_be_min,torus_be_max,dtorus_be
      real*8 torus_al_min,torus_al_max,dtorus_al
      real*8 torus_plw_min,torus_plw_max,dtorus_plw
      real*8 torus_phi_min,torus_phi_max,dtorus_phi
      real*8 agn_frac_min,agn_frac_max,dagn_frac		
      real*8 lirtot_min,lirtot_max,dlirtot			
      real*8 liragn_min,liragn_max,dliragn			
      real*8 lirsf_min,lirsf_max,dlirsf				
      !real*8 lirstars_min,lirstars_max,dlirstars		
      real*8 lacc_min,lacc_max,dlacc				

      real*8 agn_mir1_frac_min,agn_mir1_frac_max,dagn_mir1_frac
      real*8 agn_mir2_frac_min,agn_mir2_frac_max,dagn_mir2_frac
      real*8 agn_mir3_frac_min,agn_mir3_frac_max,dagn_mir3_frac
      real*8 agn_mir4_frac_min,agn_mir4_frac_max,dagn_mir4_frac
      real*8 agn_mir5_frac_min,agn_mir5_frac_max,dagn_mir5_frac
      real*8 agn_mir6_frac_min,agn_mir6_frac_max,dagn_mir6_frac

      real*8 flux_min,flux_max,dflux		

      



    
      data torus_rm_min/20./,torus_rm_max/350./,dtorus_rm/10./
      data torus_ct_min/10./,torus_ct_max/70./,dtorus_ct/10./
      data torus_ta_min/0./,torus_ta_max/10./,dtorus_ta/0.1/		
      data torus_be_min/-1.1/,torus_be_max/0.1/,dtorus_be/0.1/
      data torus_al_min/-0.1/,torus_al_max/10./,dtorus_al/0.1/
      data torus_plw_min/-1.1/,torus_plw_max/-0.0/,dtorus_plw/0.1/
      data torus_phi_min/0./,torus_phi_max/90./,dtorus_phi/1./
      data agn_frac_min/-4.9/,agn_frac_max/0./,dagn_frac/0.01/	
      data lirtot_min/4./,lirtot_max/14./,dlirtot/0.01/		
      data liragn_min/4./,liragn_max/14./,dliragn/0.01/		
      data lirsf_min/4./,lirsf_max/14./,dlirsf/0.01/		
      data lacc_min/38./,lacc_max/48./,dlacc/0.01/		
 
      data agn_mir1_frac_min/-4.9/,agn_mir1_frac_max/0./,dagn_mir1_frac/0.01/
      data agn_mir2_frac_min/-4.9/,agn_mir2_frac_max/0./,dagn_mir2_frac/0.01/
      data agn_mir3_frac_min/-4.9/,agn_mir3_frac_max/0./,dagn_mir3_frac/0.01/
      data agn_mir4_frac_min/-4.9/,agn_mir4_frac_max/0./,dagn_mir4_frac/0.01/
      data agn_mir5_frac_min/-4.9/,agn_mir5_frac_max/0./,dagn_mir5_frac/0.01/
      data agn_mir6_frac_min/-4.9/,agn_mir6_frac_max/0./,dagn_mir6_frac/0.01/

      data flux_min/-8./,flux_max/2./,dflux/0.05/		

 
    
      real*8 ptorus_rm(nbinmax1)		
      real*8 ptorus_ct(nbinmax1)
      real*8 ptorus_ta(nbinmax1)
      real*8 ptorus_be(nbinmax1)
      real*8 ptorus_al(nbinmax1)
      real*8 ptorus_plw(nbinmax1)
      real*8 ptorus_phi(nbinmax1)
      real*8 pa_torus(nbinmax1)
      real*8 pagn_frac(nbinmax1)
      real*8 plirtot(nbinmax1)
      real*8 pliragn(nbinmax1)
      real*8 plirsf(nbinmax1)
      real*8 placc(nbinmax1)
      real*8 ptau_los(nbinmax1)
 
      real*8 pagn_mir1_frac(nbinmax1)
      real*8 pagn_mir2_frac(nbinmax1)
      real*8 pagn_mir3_frac(nbinmax1)
      real*8 pagn_mir4_frac(nbinmax1)
      real*8 pagn_mir5_frac(nbinmax1)
      real*8 pagn_mir6_frac(nbinmax1)

      real*8 pflux_sfir(nmax,nbinmax1)	
      real*8 pflux_agn(nmax,nbinmax1)
      real*8 pflux_tot(nmax,nbinmax1)

      real*8 ptorus_rm2(nbinmax2)		
      real*8 ptorus_ct2(nbinmax2)
      real*8 ptorus_ta2(nbinmax2)
      real*8 ptorus_be2(nbinmax2)
      real*8 ptorus_al2(nbinmax2)
      real*8 ptorus_plw2(nbinmax2)
      real*8 ptorus_phi2(nbinmax2)
      real*8 pa_torus2(nbinmax2)
      real*8 pagn_frac2(nbinmax2)
      real*8 plirtot2(nbinmax2)
      real*8 pliragn2(nbinmax2)
      real*8 plirsf2(nbinmax2)
      real*8 placc2(nbinmax2)
      real*8 ptau_los2(nbinmax2)

      real*8 pagn_mir1_frac2(nbinmax2)
      real*8 pagn_mir2_frac2(nbinmax2)
      real*8 pagn_mir3_frac2(nbinmax2)
      real*8 pagn_mir4_frac2(nbinmax2)
      real*8 pagn_mir5_frac2(nbinmax2)
      real*8 pagn_mir6_frac2(nbinmax2)

      real*8 pflux_sfir2(nmax,nbinmax2)	
      real*8 pflux_agn2(nmax,nbinmax2)
      real*8 pflux_tot2(nmax,nbinmax2)

      integer nbin_torus_rm,nbin_torus_ct,nbin_torus_ta		
      integer nbin_torus_be,nbin_torus_al
      integer nbin_torus_plw,nbin_torus_phi
      integer nbin_a_torus,nbin_agn_frac
      integer nbin_lirtot,nbin_liragn,nbin_lirsf
      integer nbin_lacc

      integer nbin_lmir1tot,nbin_lmir1agn,nbin_agn_mir1_frac
      integer nbin_lmir2tot,nbin_lmir2agn,nbin_agn_mir2_frac
      integer nbin_lmir3tot,nbin_lmir3agn,nbin_agn_mir3_frac
      integer nbin_lmir4tot,nbin_lmir4agn,nbin_agn_mir4_frac
      integer nbin_lmir5tot,nbin_lmir5agn,nbin_agn_mir5_frac
      integer nbin_lmir6tot,nbin_lmir6agn,nbin_agn_mir6_frac

      integer nbin_flux

      integer nbin2_torus_rm,nbin2_torus_ct,nbin2_torus_ta	
      integer nbin2_torus_be,nbin2_torus_al
      integer nbin2_torus_plw,nbin2_torus_phi
      integer nbin2_a_torus,nbin2_agn_frac
      integer nbin2_lirtot,nbin2_liragn,nbin2_lirsf
      integer nbin2_lacc
 
      integer nbin2_lmir1tot,nbin2_lmir1agn,nbin2_agn_mir1_frac
      integer nbin2_lmir2tot,nbin2_lmir2agn,nbin2_agn_mir2_frac
      integer nbin2_lmir3tot,nbin2_lmir3agn,nbin2_agn_mir3_frac
      integer nbin2_lmir4tot,nbin2_lmir4agn,nbin2_agn_mir4_frac
      integer nbin2_lmir5tot,nbin2_lmir5agn,nbin2_agn_mir5_frac
      integer nbin2_lmir6tot,nbin2_lmir6agn,nbin2_agn_mir6_frac
 
      integer nbin2_flux
    
      real*8 torus_rm_hist(nbinmax1)				
      real*8 torus_ct_hist(nbinmax1)
      real*8 torus_ta_hist(nbinmax1)
      real*8 torus_be_hist(nbinmax1)
      real*8 torus_al_hist(nbinmax1)
      real*8 torus_plw_hist(nbinmax1)
      real*8 torus_phi_hist(nbinmax1)
      real*8 a_torus_hist(nbinmax1)
      real*8 agn_frac_hist(nbinmax1)
      real*8 lirtot_hist(nbinmax1)
      real*8 liragn_hist(nbinmax1)
      real*8 lirsf_hist(nbinmax1)
      real*8 lacc_hist(nbinmax1)
 
      real*8 agn_mir1_frac_hist(nbinmax1)
      real*8 agn_mir2_frac_hist(nbinmax1)
      real*8 agn_mir3_frac_hist(nbinmax1)
      real*8 agn_mir4_frac_hist(nbinmax1)
      real*8 agn_mir5_frac_hist(nbinmax1)
      real*8 agn_mir6_frac_hist(nbinmax1)
   
      real*8 flux_hist(nbinmax1)

      real*8 torus_rm2_hist(nbinmax2)				
      real*8 torus_ct2_hist(nbinmax2)
      real*8 torus_ta2_hist(nbinmax2)
      real*8 torus_be2_hist(nbinmax2)
      real*8 torus_al2_hist(nbinmax2)
      real*8 torus_plw2_hist(nbinmax2)
      real*8 torus_phi2_hist(nbinmax2)
      real*8 a_torus2_hist(nbinmax2)
      real*8 agn_frac2_hist(nbinmax2)
      real*8 lirtot2_hist(nbinmax2)
      real*8 liragn2_hist(nbinmax2)
      real*8 lirsf2_hist(nbinmax2)
      real*8 lacc2_hist(nbinmax2)

      real*8 agn_mir1_frac2_hist(nbinmax2)
      real*8 agn_mir2_frac2_hist(nbinmax2)
      real*8 agn_mir3_frac2_hist(nbinmax2)
      real*8 agn_mir4_frac2_hist(nbinmax2)
      real*8 agn_mir5_frac2_hist(nbinmax2)
      real*8 agn_mir6_frac2_hist(nbinmax2)
 
      real*8 flux_2_hist(nbinmax2)

      integer i_torus_rm(ntorus)			    
      integer i_torus_ct(ntorus)
      integer i_torus_ta(ntorus)
      integer i_torus_be(ntorus)
      integer i_torus_al(ntorus)
      integer i_torus_plw(ntorus)
      integer i_torus_phi(ntorus)
      integer i_a_torus(ntorus)
      integer i_agn_frac(ntorus)
      integer i_tau_los(ntorus)
     
      real ran1					

      integer iseed1			
      integer iseed2			
      integer iseed3			
      integer iseed4			
      
      real*8 prannorm(nbinmax1)
      real*8 prannorm2(nbinmax2)
      real*8 rannorm_hist(nbinmax1)
      real*8 rannorm2_hist(nbinmax2)
      
      real*8 flux_res(nmax)		
       
      real*8 a_torus			
      real*8 a_torus_tmp
      real*8 a_torus_min,a_torus_max,da_torus
      data a_torus_min/-10./,a_torus_max/10./,da_torus/0.005/		
      
      integer torus_sav			
      real*8 a_torus_sav		

      real*8 pct_torus_rm(5)		
      real*8 pct_torus_ct(5)
      real*8 pct_torus_ta(5)
      real*8 pct_torus_be(5)
      real*8 pct_torus_al(5)
      real*8 pct_torus_plw(5)
      real*8 pct_torus_phi(5)
      real*8 pct_a_torus(5)
      real*8 pct_agn_frac(5)
      real*8 pct_tau_los(5)

      real*8 pct_lirtot(5)
      real*8 pct_liragn(5)
      real*8 pct_lirsf(5)
      real*8 pct_lacc(5)
 
      real*8 pct_agn_mir1_frac(5)
      real*8 pct_agn_mir2_frac(5)
      real*8 pct_agn_mir3_frac(5)
      real*8 pct_agn_mir4_frac(5)
      real*8 pct_agn_mir5_frac(5)
      real*8 pct_agn_mir6_frac(5)

      real*8 pct_flux_sfir(nmax,5)	
      real*8 pct_flux_agn(nmax,5)
      real*8 pct_flux_tot(nmax,5)
  
      character*20 sdummy
      real*8 dummy
      character hour*10
      character day*8

      CHARACTER*2 st_h, st_m, st_day, st_mnt
      CHARACTER*2 en_h, en_m, en_day, en_mnt
      CHARACTER*4 st_y, en_y
      CHARACTER*6 st_s, en_s
      
      real*8 agn_fraction,agn_fraction_sav
      real*8 log_agn_fraction
 
      real*8 agn_mir1_fraction,agn_mir1_fraction_sav
      real*8 agn_mir2_fraction,agn_mir2_fraction_sav
      real*8 agn_mir3_fraction,agn_mir3_fraction_sav
      real*8 agn_mir4_fraction,agn_mir4_fraction_sav
      real*8 agn_mir5_fraction,agn_mir5_fraction_sav
      real*8 agn_mir6_fraction,agn_mir6_fraction_sav
     
      real*8 trapz8
      
      real*8 lambda_agn_frac_min,lambda_agn_frac_max

      real LIR_torus(ntorus), LIR_sf(nmod), LIR_sfh(nmod)
      real LMIR1_torus(ntorus), LMIR1_sf(nmod), LMIR1_sfh(nmod)
      real LMIR2_torus(ntorus), LMIR2_sf(nmod), LMIR2_sfh(nmod)
      real LMIR3_torus(ntorus), LMIR3_sf(nmod), LMIR3_sfh(nmod)
      real LMIR4_torus(ntorus), LMIR4_sf(nmod), LMIR4_sfh(nmod)
      real LMIR5_torus(ntorus), LMIR5_sf(nmod), LMIR5_sfh(nmod)
      real LMIR6_torus(ntorus), LMIR6_sf(nmod), LMIR6_sfh(nmod)

      real lir_tot_sav, lir_tot
      real lir_agn_sav, lir_agn
      real lacc_sav
      real lir_starform_sav, lir_starform
      
      real lmir1_tot_sav, lmir1_tot
      real lmir2_tot_sav, lmir2_tot
      real lmir3_tot_sav, lmir3_tot
      real lmir4_tot_sav, lmir4_tot
      real lmir5_tot_sav, lmir5_tot
      real lmir6_tot_sav, lmir6_tot
      
      real lmir1_agn_sav, lmir1_agn
      real lmir2_agn_sav, lmir2_agn
      real lmir3_agn_sav, lmir3_agn
      real lmir4_agn_sav, lmir4_agn
      real lmir5_agn_sav, lmir5_agn
      real lmir6_agn_sav, lmir6_agn
      
      real*8 l_accretion
 
      real diffz_choice,zlib_choice
 
      character*20 outfile3
      character*20 outfile4
 
      character*30 convlib1
      character*30 convlib2
      character*30 convlib3

      integer kfile(nmod)	


      
      integer n_ran_opt				
      integer n_ran_ir				
      integer n_ran_norm			
      integer n_ran_torus			
      
      integer print_all_out			
      integer print_pho_pdf			
    
      character*20 lib_dir			
      	
      character*50 torus_list			
      character*80 infile1,infile1b,infile2
      
      integer use_rdn_t				
      integer use_up_lim			
      
      





c     ---------------------------------------------------------------------------

      ! record start time

	! Start Time (works only under Linux)

	CALL date_and_time(day,hour)
	st_h=hour(1:2)
	st_m=hour(3:4)
	st_s=hour(5:10)
	st_day=day(7:8)
	st_mnt=day(5:6)
	st_y=day(1:4)

c     ---------------------------------------------------------------------------


	write(*,*) '-----------------------'
	write(*,*) '        SED3FIT        '
	write(*,*)
	write(*,*) '   by Stefano Berta    '
	write(*,*)
	write(*,*) ' SED fitting including '
	write(*,*) '    stars+dust+AGN     '
	write(*,*) '-----------------------'


c     ---------------------------------------------------------------------------

	! compute pigrec
	
	pigrec=4.d0*datan(1.d0)
	

c     ---------------------------------------------------------------------------

	! read new input file
	
      close(22)

      open(22,file='input_sed3fit',status='old')

      read(22,*) sdummy, obs	 	
      read(22,*) sdummy, filters  	
      read(22,*) sdummy, sdummy		
      read(22,*) sdummy, sdummy		
      read(22,*) sdummy, sdummy		
      read(22,*) sdummy, infile1 	
      read(22,*) sdummy, infile1b	
      read(22,*) sdummy, infile2 	
      read(22,*) sdummy, torus_list	
      read(22,*) sdummy, convlib1	
      read(22,*) sdummy, convlib2	
      read(22,*) sdummy, convlib3	
      read(22,*) sdummy, lib_dir	
      read(22,*) sdummy, n_ran_opt
      read(22,*) sdummy, n_ran_ir
      read(22,*) sdummy, n_ran_norm
      read(22,*) sdummy, n_ran_torus
      read(22,*) sdummy, print_all_out
      read(22,*) sdummy, print_pho_pdf
      read(22,*) sdummy, use_up_lim	
      read(22,*) sdummy, use_rdn_t
      !read(22,*) sdummy, 
      
      close(22)

            
c     ---------------------------------------------------------------------------
c     Set things up: what filters to use, observations and models:
c     ---------------------------------------------------------------------------

c     READ FILTER FILE: "filters.dat"
      close(22)
      open(22,file=filters,status='old')
      do i=1,1
         read(22,*)
      enddo
      io=0
      ifilt=0
      do while(io.eq.0)
         ifilt=ifilt+1
         read(22,*,iostat=io) filt_name(ifilt),lambda_eff(ifilt),filt_id(ifilt),fit(ifilt)
      enddo
      nfilt=ifilt-1
      close(22)
 
      
c     READ FILE WITH OBSERVATIONS:
      close(20)
      open(20,file=obs,status='old')
      do i=1,1
         read(20,*)
      enddo
      io=0
      n_obs=0
      do while(io.eq.0)
         n_obs=n_obs+1
         read(20,*,iostat=io) gal_name(n_obs),redshift(n_obs),
     +        (flux_obs(n_obs,k),sigma(n_obs,k),k=1,nfilt)
      enddo
      n_obs=n_obs-1
      close(20)

c     READ FILE WITH REDSHIFTS OF THE MODEL LIBRARIES
      close(24)
      open(24,file='zlibs.dat',status='old')
      io=0
      nz=0
      do while(io.eq.0)
         nz=nz+1
         read(24,*,iostat=io) i,zlib(nz)
         enddo
         nz=nz-1
          
c     CHOOSE GALAXY TO FIT (enter corresponding i)
      write (6,'(x,a,$)') 'Choose galaxy - enter i_gal: '
      read (5,*) i_gal
      write(*,*) i_gal
        
c     WHAT OBSERVATIONS DO YOU WANT TO FIT?
c     fit(ifilt)=1: fit flux from filter ifilt
c     fit(ifilt)=0: do not fit flux from filter ifilt (set flux=-99)
      do ifilt=1,nfilt
         if (fit(ifilt).eq.0) then
            flux_obs(i_gal,ifilt)=-99.
            sigma(i_gal,ifilt)=-99.
         endif
      enddo

c     Count number of non-zero fluxes (i.e. detections) to fit
      n_flux=0
      do k=1,nfilt
         if (flux_obs(i_gal,k).gt.0) then
            n_flux=n_flux+1
         endif
      enddo
      
      clambda=cosmol_c(h,omega,omega_lambda,q)
      
      dist(i_gal)=dl(h,q,redshift(i_gal))
      dist(i_gal)=dist(i_gal)*3.086e+24/dsqrt(1.+redshift(i_gal))
      
      
c     OUTPUT FILES
      aux_name=gal_name(i_gal)
      outfile1=aux_name(1:largo(aux_name))//'.fit'
      outfile2=aux_name(1:largo(aux_name))//'.sed'
      outfile3=aux_name(1:largo(aux_name))//'.all'
      outfile4=aux_name(1:largo(aux_name))//'.pho'
      close(31) 
      open (31, file=outfile1, status='unknown')

      if(print_all_out .eq. 1) then
	close(33) 
      	open(33, file=outfile3, status='unknown')
        write(33,*)'ID(stars),flag(lib=1/2),ID(dust)'
      end if
      
c     Choose libraries according to the redshift of the source
c     Find zlib(i) closest of the galaxie's redshift
      do i=1,nz
         diffz(i)=abs(zlib(i)-redshift(i_gal))
      enddo




      diffz_choice=100.
      zlib_choice=0.0
	
      do i=1,nz
	
            if (diffz(i) .lt. diffz_choice) then
                  diffz_choice=diffz(i)
                  zlib_choice=zlib(i)
            else if(diffz(i) .eq. diffz_choice 
     2            .and. zlib_choice .lt. redshift(i_gal)
     2            .and. zlib(i) .ge. redshift(i_gal)) then
                  diffz_choice=diffz(i)
                  zlib_choice=zlib(i)
            end if	
      end do

      write(numz,'(f6.4)') zlib_choice

      if (diffz_choice.gt.0.005.and.mod(redshift(i_gal)*1000,10.).ne.5) then
         write(*,*) 'No model library at this galaxy redshift...'
         stop
      endif

	
	
      write(*,*)'Seeking libraries in the directory', lib_dir(1:largo(lib_dir))
      
      optlib = 
     2 lib_dir(1:largo(lib_dir))//convlib1(1:largo(convlib1))//numz//'.lbr'	! Charlot & Bruzual (2007)
      
      irlib = 
     2 lib_dir(1:largo(lib_dir))//convlib2(1:largo(convlib2))//numz//'.lbr'	! it needs to be computed with the new version of get_ir_colors

      toruslib = 
     2 lib_dir(1:largo(lib_dir))//convlib3(1:largo(convlib3))//numz//'.lbr'	! (added by Stefano Berta)

      write(*,*) 'z= ',redshift(i_gal)
      write(*,*) 'optilib=',optlib
      write(*,*) 'irlib=',irlib
      write(*,*) 'toruslib=',toruslib			! (added by Stefano Berta)

 
c     ---------------------------------------------------------------------------
c     What part of the SED are the filters sampling at the redshift of the galaxy?
c     - lambda(rest-frame) < 2.5 mic : emission purely stellar (attenuated by dust)
c     - 2.5 mic < lambda(rest-frame) < 10 mic : stellar + dust emission
c     - lambda(rest-frame) > 10 mic : emission purely from dust
c     ---------------------------------------------------------------------------

         nfilt_sfh=0            !nr of filters sampling the stellar emission
         nfilt_ir=0             !nr of filters sampling the dust emission
         nfilt_mix=0            !nr of filters sampling stellar+dust emission
         do i=1,nfilt
            lambda_rest(i)=lambda_eff(i)/(1.+redshift(i_gal))
            if (lambda_rest(i).lt.10.) then
               nfilt_sfh=nfilt_sfh+1
               kfilt_sfh(nfilt_sfh)=i
            endif
            if (lambda_rest(i).gt.2.5) then
               nfilt_ir=nfilt_ir+1
               kfilt_ir(nfilt_ir)=i
            endif
            if (lambda_rest(i).gt.2.5.and.lambda_rest(i).le.10) then
               nfilt_mix=nfilt_mix+1
            endif
         enddo

         write(*,*) '   '
         write(*,*) 'At this redshift: '

         do k=1,nfilt_sfh-nfilt_mix
            write(*,*) 'purely stellar... ',filt_name(k)
         enddo
         do k=nfilt_sfh-nfilt_mix+1,nfilt_sfh
            write(*,*) 'mix stars+dust... ',filt_name(k)
         enddo
         do k=nfilt_sfh+1,nfilt
            write(*,*) 'purely dust... ',filt_name(k)
         enddo
         
	 write(*,*) 'NOTE: Torus adds to all filters!'		! (added by Stefano Berta)

 
      do i=nfilt,1,-1
         if(lambda_rest(i).ge.7.9)then
	     lambda_agn_frac_min=lambda_rest(i)
	 end if
      end do 
 
      do i=1,nfilt
         if(lambda_rest(i).le.1000.0)then
	     lambda_agn_frac_max=lambda_rest(i)
	 end if
      end do 
 



c     ---------------------------------------------------------------------------
c     MODELS: read libraries of models with parameters + AB mags at z
c     attenuated stellar emission - optlib: starformhist_cb07_z###.lbr
c     --> nfilt_sfh model absolute AB mags
c     dust emission - irlib: infrared_dce08_z###.lbr
c     --> nfilt_ir model absolute AB mags
c     torus emission: torus_f06_z###.lbr
c     --> nfilt model absolute AB mags
c     ---------------------------------------------------------------------------

         if (isave.eq.0) then
            io=0



c     READ OPTLIB
            close(21)
            open(21,file=optlib,status='old')
            do i=1,2
               read(21,*) !2 lines of header
            enddo
            write(*,*) 'Reading SFH library...'
            i_sfh=0
            io=0
            do while(io.eq.0)
               i_sfh=i_sfh+1
               read(21,*,iostat=io) indx(i_sfh),kfile(i_sfh),
     +              (fprop_sfh(i_sfh,j),j=1,nprop_sfh),
     +		    lir_sfh(i_sfh),lmir1_sfh(i_sfh),
     +		    lmir2_sfh(i_sfh),lmir3_sfh(i_sfh),
     +		    lmir4_sfh(i_sfh),lmir5_sfh(i_sfh),lmir6_sfh(i_sfh),
     +              (flux_sfh(i_sfh,j),j=1,nfilt_sfh)
               if (io.eq.0) then
c     Relevant physical parameters
                  fmu_sfh(i_sfh)=fprop_sfh(i_sfh,22)            ! fmu parameter Ld(ISM)/Ld(tot) - optical
                  mstr1(i_sfh)=fprop_sfh(i_sfh,6)               ! stellar mass
                  ldust(i_sfh)=fprop_sfh(i_sfh,21)/mstr1(i_sfh) ! total luminosity of dust (normalize to Mstar)
                  logldust(i_sfh)=dlog10(ldust(i_sfh))          ! log(Ldust)
                  mu(i_sfh)=fprop_sfh(i_sfh,5)                  ! mu parameter (CF00 model)
                  tauv(i_sfh)=fprop_sfh(i_sfh,4)                ! optical V-band depth tauV (CF00 model)
                  tform(i_sfh)=fprop_sfh(i_sfh,1)		! age of oldest stars
                  ltform(i_sfh)=dlog10(tform(i_sfh))		! log version
		  age_wm(i_sfh)=fprop_sfh(i_sfh,19)		! Mass-weighted age
		  lage_wm(i_sfh)=dlog10(age_wm(i_sfh))		! log version
		  age_wr(i_sfh)=fprop_sfh(i_sfh,20)		! R-band weighted age
		  lage_wr(i_sfh)=dlog10(age_wr(i_sfh))		! log version
                  ssfr6(i_sfh)=fprop_sfh(i_sfh,8)/mstr1(i_sfh)   ! recent SSFR_0.001Gyr / stellar mass, i.e. using SFR integrated over 1 Myr
                  ssfr7(i_sfh)=fprop_sfh(i_sfh,9)/mstr1(i_sfh)   ! recent SSFR_0.01Gyr / stellar mass, i.e. using SFR integrated over 10 Myr
		  ssfr8(i_sfh)=fprop_sfh(i_sfh,10)/mstr1(i_sfh)  ! recent SSFR_0.1Gyr / stellar mass, i.e. using SFR integrated over 100 Myr
		  lssfr6(i_sfh)=dlog10(ssfr6(i_sfh))              ! log(SSFR_0.001Gyr)
		  lssfr7(i_sfh)=dlog10(ssfr7(i_sfh))              ! log(SSFR_0.01Gyr)
		  lssfr8(i_sfh)=dlog10(ssfr8(i_sfh))              ! log(SSFR_0.1Gyr)
                  tvism(i_sfh)=mu(i_sfh)*tauv(i_sfh)            ! mu*tauV=V-band optical depth for ISM
c     .lbr contains absolute AB magnitudes -> convert to fluxes Fnu in Lo/Hz
c     Convert all magnitudes to Lo/Hz (except H lines luminosity: in Lo)
c     Normalise SEDs to stellar mass
                  do k=1,nfilt_sfh
                     flux_sfh(i_sfh,k)=3.117336e+6
     +                    *10**(-0.4*(flux_sfh(i_sfh,k)+48.6))
                     flux_sfh(i_sfh,k)=flux_sfh(i_sfh,k)/mstr1(i_sfh)
c     1+z factor which is required in model fluxes
                     flux_sfh(i_sfh,k)=flux_sfh(i_sfh,k)/(1+redshift(i_gal))
                  enddo
               endif
            enddo
            close(21)
            n_sfh=i_sfh-1

c     READ IRLIB
            close(20)
            open(20,file=irlib,status='old')
            do i=1,2
               read(20,*)  !2 lines of header
            enddo
            write(*,*) 'Reading IR dust emission library...'
            i_ir=0
            io=0
            do while(io.eq.0)
               i_ir=i_ir+1
               read(20,*,iostat=io) (fprop_ir(i_ir,j),j=1,nprop_ir),
     +              LIR_sf(i_ir),LMIR1_sf(i_ir),LMIR2_sf(i_ir),
     +              LMIR3_sf(i_ir),LMIR4_sf(i_ir),LMIR5_sf(i_ir),
     +		    LMIR6_sf(i_ir),(flux_ir(i_ir,j),j=1,nfilt_ir)
c     IR model parameters
               fmu_ir(i_ir)=fprop_ir(i_ir,1)       ! fmu parameter Ld(ISM)/Ld(tot) - infrared
               fmu_ism(i_ir)=fprop_ir(i_ir,2)      ! xi_C^ISM [cont. cold dust to Ld(ISM)]
               tbg2(i_ir)=fprop_ir(i_ir,4)         ! T_C^ISM [eq. temp. cold dust in ISM]
               tbg1(i_ir)=fprop_ir(i_ir,3)         ! T_W^BC [eq. temp. warm dust in birth clouds]
               xi1(i_ir)=fprop_ir(i_ir,5)          ! xi_PAH^BC Ld(PAH)/Ld(BC)
               xi2(i_ir)=fprop_ir(i_ir,6)          ! xi_MIR^BC Ld(MIR)/Ld(BC)
               xi3(i_ir)=fprop_ir(i_ir,7)          ! xi_W^BC Ld(warm)/Ld(BC)
               mdust(i_ir)=fprop_ir(i_ir,8) !dust mass
c     .lbr contains absolute AB magnitudes -> convert to fluxes Fnu in Lo/Hz
c     Convert all magnitudes to Lo/Hz
               do k=1,nfilt_ir
                  flux_ir(i_ir,k)=3.117336e+6
     +                 *10**(-0.4*(flux_ir(i_ir,k)+48.6))
                  flux_ir(i_ir,k)=flux_ir(i_ir,k)/(1+redshift(i_gal))
               enddo
c     Re-define IR parameters: xi^tot
               xi1(i_ir)=xi1(i_ir)*(1.-fmu_ir(i_ir))+
     +              0.550*(1-fmu_ism(i_ir))*fmu_ir(i_ir) ! xi_PAH^tot Ld(PAH)/Ld(tot)
               xi2(i_ir)=xi2(i_ir)*(1.-fmu_ir(i_ir))+
     +              0.275*(1-fmu_ism(i_ir))*fmu_ir(i_ir) ! xi_MIR^tot Ld(MIR)/Ld(tot)
               xi3(i_ir)=xi3(i_ir)*(1.-fmu_ir(i_ir))+
     +              0.175*(1-fmu_ism(i_ir))*fmu_ir(i_ir) ! xi_W^tot Ld(warm)/Ld(tot)
               fmu_ism(i_ir)=fmu_ism(i_ir)*fmu_ir(i_ir)  ! xi_C^tot Ld(cold)/Ld(tot)
            enddo
 201        format(0p7f12.3,1pe12.3,1p14e12.3,1p3e12.3)
            close(20)
            n_ir=i_ir-1
            isave=1
         endif



c     READ TORUSLIB
            close(23)
            open(23,file=toruslib,status='old')
            !do i=1,
               read(23,*) !1 lines of header
            !enddo
            write(*,*) 'Reading TORUS library...'
            
	    io=0
            i_torus=0
            do while(io.eq.0)
               i_torus=i_torus+1
               read(23,*,iostat=io) torus_id(i_torus),torus_rm(i_torus),
     2		torus_ct(i_torus),torus_ta(i_torus),torus_be(i_torus),
     2		torus_al(i_torus),torus_plw(i_torus),torus_phi(i_torus),
     2		LIR_torus(i_torus),LMIR1_torus(i_torus),LMIR2_torus(i_torus),
     2		LMIR3_torus(i_torus),LMIR4_torus(i_torus),LMIR5_torus(i_torus),
     2		LMIR6_torus(i_torus),(flux_torus(i_torus,j),j=1,nfilt)
     
               if (io.eq.0) then
c     .lbr contains absolute AB magnitudes -> convert to fluxes Fnu in Lo/Hz
c     Convert all magnitudes to Lo/Hz 
                  do k=1,nfilt
                     flux_torus(i_torus,k)=3.117336e+6*
     +                    10.**(-0.4*(flux_torus(i_torus,k)+48.6))
c     1+z factor which is required in model fluxes
                     flux_torus(i_torus,k)=flux_torus(i_torus,k)/(1+redshift(i_gal))
		     
		     if(lambda_rest(k).gt.1000.0) then	! the torus model is limited to max 1000um only
		     	flux_torus(i_torus,k)=0.0
		     end if
		     
                  enddo
               endif
            enddo
            close(23)

            tot_torus=i_torus-1

	 write(*,*)'There are ',tot_torus,' torus models in total'
	 
	 
c     ---------------------------------------------------------------------------
	 
	 
	
	do i=1,tot_torus
		
		if(torus_phi(i) .lt. 2.d0*(90.d0-torus_ct(i)))then

			tau_los(i)=torus_ta(i) * dexp(-1*torus_al(i) * 
     2			dabs(dcos(pigrec/2.d0-torus_phi(i)*pigrec/180.d0)))
	 	
		else
		
			tau_los(i)=0.0d0
	 	
		end if

!		write(*,*) torus_phi(i), torus_ct(i), torus_ta(i), 
!     2		torus_al(i), tau_los(i)
		
	end do
	 

c     ---------------------------------------------------------------------------


      if (use_rdn_t.eq.1) then
		dummy_do_torus=n_ran_torus
      else if (use_rdn_t.eq.0) then
      		dummy_do_torus=tot_torus
      end if


c     ---------------------------------------------------------------------------
c     COMPARISON BETWEEN MODELS AND OBSERVATIONS:
c
c     Compare everything in the sample units:
c     Lnu (i.e. luminosity per unit frequency) in Lsun/Hz
c
c     Model fluxes: already converted from AB mags to Lnu in Lsun/Hz
c     Fluxes and physical parameters from optical library per unit Mstar=1 Msun
c     Fluxes and physical parameters from infrared library per unit Ldust=1 Lsun
c
c     Observed fluxes & uncertainties
c     Convert from Fnu in Jy to Lnu in Lo/Hz [using luminosity distance dist(i_gal)]
c     ---------------------------------------------------------------------------

c     Observed fluxes: Jy -> Lsun/Hz
         do k=1,nfilt
            if (flux_obs(i_gal,k).gt.0.and.sigma(i_gal,k).gt.0.) then
               flux_obs(i_gal,k)=flux_obs(i_gal,k)*1.e-23
     +              *3.283608731e-33*(dist(i_gal)**2)
               sigma(i_gal,k)=sigma(i_gal,k)*1.e-23
     +              *3.283608731e-33*(dist(i_gal)**2)
            endif
            if (flux_obs(i_gal,k).le.0.and.sigma(i_gal,k).gt.0.) then
               sigma(i_gal,k)=sigma(i_gal,k)*1.e-23
     +              *3.283608731e-33*(dist(i_gal)**2)
            endif
            if (flux_obs(i_gal,k).gt.0.and.sigma(i_gal,k).lt.
     +	    0.05*flux_obs(i_gal,k)) then
               sigma(i_gal,k)=0.05*flux_obs(i_gal,k)
            endif
         enddo
         
         do k=1,nfilt
            if (sigma(i_gal,k).gt.0.0) then
               w(i_gal,k) = 1.0 / (sigma(i_gal,k)**2)
            endif
         enddo
         
c     ---------------------------------------------------------------------------
c     Initialize variables:
         n_models=0
         chi2_sav=1.e+30
         ptot=0.
         prob=0.
         do k=1,nfilt
            flux_mod(k)=0.
         enddo


         do i=1,1500
            psfh(i)=0.
            pir(i)=0.
            pmu(i)=0.
            ptv(i)=0.
            ptvism(i)=0.
            pssfr6(i)=0.
            pssfr7(i)=0.
            pssfr8(i)=0.
            psfr6(i)=0.
            psfr7(i)=0.
            psfr8(i)=0.
            pa(i)=0.
            pldust(i)=0.
            ptbg1(i)=0.
            ptbg2(i)=0.
            pism(i)=0.
            pxi1(i)=0.
            pxi2(i)=0.
            pxi3(i)=0.
            pmd(i)=0.
	    ptform(i)=0.
	    page_wm(i)=0.
	    page_wr(i)=0.
	    
	    ptorus_rm(i)=0.		
	    ptorus_ct(i)=0.
	    ptorus_ta(i)=0.
	    ptorus_be(i)=0.
	    ptorus_al(i)=0.
	    ptorus_plw(i)=0.
	    ptorus_phi(i)=0.
	    ptau_los(i)=0.
	    
	    !ptau_los(i)=0.
	    
	    pa_torus(i)=0.
	    
	    pagn_frac(i)=0.

	    plirtot(i)=0
	    pliragn(i)=0
	    plirsf(i)=0
	    placc(i)=0

	    !plmir1tot(i)=0.
	    !plmir2tot(i)=0.
	    !plmir3tot(i)=0.
	    !plmir4tot(i)=0.
	    !plmir5tot(i)=0.

	    !plmir1agn(i)=0.
	    !plmir2agn(i)=0.
	    !plmir3agn(i)=0.
	    !plmir4agn(i)=0.
	    !plmir5agn(i)=0.

	    pagn_mir1_frac(i)=0.
	    pagn_mir2_frac(i)=0.
	    pagn_mir3_frac(i)=0.
	    pagn_mir4_frac(i)=0.
	    pagn_mir5_frac(i)=0.
	    pagn_mir6_frac(i)=0.

		if(print_pho_pdf.eq.1)then 
		 do j=1,nfilt
		
			pflux_sfir(j,i)=0.
			pflux_agn(j,i)=0.
			pflux_tot(j,i)=0.
		
		 end do
		end if ! on print_pho_pdf=1


         enddo

c     ---------------------------------------------------------------------------
c     Compute histogram grids of the parameter likelihood distributions before
c     starting the big loop in which we compute chi^2 for each allowed combination
c     of stellar+dust emission model (to save time).
c
c     The high-resolution marginalized likelihood distributions will be
c     computed on-the-run
c     ---------------------------------------------------------------------------

c     f_mu (SFH) & f_mu (IR)               
         call get_histgrid(dfmu,fmu_min,fmu_max,nbin_fmu,fmu_hist)
c     mu parameter
         call get_histgrid(dmu,mu_min,mu_max,nbin_mu,mu_hist)
c     tauv (dust optical depth)
         call get_histgrid(dtv,tv_min,tv_max,nbin_tv,tv_hist)
c     sSFR    
         call get_histgrid(dssfr,ssfr_min,ssfr_max,nbin_ssfr,ssfr_hist)
c     SFR    
         call get_histgrid(dsfr,sfr_min,sfr_max,nbin_sfr,sfr_hist)
c     Mstars     
         call get_histgrid(da,a_min,a_max,nbin_a,a_hist)
c     Ldust   
         call get_histgrid(dldust,ld_min,ld_max,nbin_ld,ld_hist)
c     fmu_ism
         call get_histgrid(dfmu_ism,fmuism_min,fmuism_max,nbin_fmu_ism,
     +        fmuism_hist)
c     T_BGs (ISM)
         call get_histgrid(dtbg,tbg1_min,tbg1_max,nbin_tbg1,tbg1_hist)
c     T_BGs (BC)
         call get_histgrid(dtbg,tbg2_min,tbg2_max,nbin_tbg2,tbg2_hist)
c     xi's (PAHs, VSGs, BGs)
         call get_histgrid(dxi,xi_min,xi_max,nbin_xi,xi_hist)
c     Mdust
         call get_histgrid(dmd,md_min,md_max,nbin_md,md_hist)
c     tform
         call get_histgrid(dage,age_min,age_max,nbin_age,age_hist)

!     torus parameters 
         call get_histgrid(dtorus_rm,torus_rm_min,torus_rm_max,
     2	 nbin_torus_rm,torus_rm_hist)
         call get_histgrid(dtorus_ct,torus_ct_min,torus_ct_max,
     2	 nbin_torus_ct,torus_ct_hist)
         call get_histgrid(dtorus_ta,torus_ta_min,torus_ta_max,
     2	 nbin_torus_ta,torus_ta_hist)
         call get_histgrid(dtorus_be,torus_be_min,torus_be_max,
     2	 nbin_torus_be,torus_be_hist)
         call get_histgrid(dtorus_al,torus_al_min,torus_al_max,
     2	 nbin_torus_al,torus_al_hist)
         call get_histgrid(dtorus_plw,torus_plw_min,torus_plw_max,
     2	 nbin_torus_plw,torus_plw_hist)
         call get_histgrid(dtorus_phi,torus_phi_min,torus_phi_max,
     2	 nbin_torus_phi,torus_phi_hist)
         call get_histgrid(da_torus,a_torus_min,a_torus_max,
     2	 nbin_a_torus,a_torus_hist)

         call get_histgrid(dagn_frac,agn_frac_min,agn_frac_max,
     2	 nbin_agn_frac,agn_frac_hist)

         call get_histgrid(dlirtot,lirtot_min,lirtot_max,
     2	 nbin_lirtot,lirtot_hist)

         call get_histgrid(dliragn,liragn_min,liragn_max,
     2	 nbin_liragn,liragn_hist)

         call get_histgrid(dlirsf,lirsf_min,lirsf_max,
     2	 nbin_lirsf,lirsf_hist)

         call get_histgrid(dlacc,lacc_min,lacc_max,
     2	 nbin_lacc,lacc_hist)


         call get_histgrid(dagn_mir1_frac,agn_mir1_frac_min,agn_mir1_frac_max,
     2	 nbin_agn_mir1_frac,agn_mir1_frac_hist)

         call get_histgrid(dagn_mir2_frac,agn_mir2_frac_min,agn_mir2_frac_max,
     2	 nbin_agn_mir2_frac,agn_mir2_frac_hist)

         call get_histgrid(dagn_mir3_frac,agn_mir3_frac_min,agn_mir3_frac_max,
     2	 nbin_agn_mir3_frac,agn_mir3_frac_hist)

         call get_histgrid(dagn_mir4_frac,agn_mir4_frac_min,agn_mir4_frac_max,
     2	 nbin_agn_mir4_frac,agn_mir4_frac_hist)

         call get_histgrid(dagn_mir5_frac,agn_mir5_frac_min,agn_mir5_frac_max,
     2	 nbin_agn_mir5_frac,agn_mir5_frac_hist)

         call get_histgrid(dagn_mir6_frac,agn_mir6_frac_min,agn_mir6_frac_max,
     2	 nbin_agn_mir6_frac,agn_mir6_frac_hist)
     
	 if(print_pho_pdf.eq.1)then 
          do j=1,nfilt
	
	       	call get_histgrid(dflux,flux_min,flux_max,nbin_flux,
     2		flux_hist)

	 
	  end do	
	 end if ! on print_pho_pdf=1


c     Compute histogram indexes for each parameter value
c     [makes code faster -- implemented by the Nottingham people]

         do i_sfh=1, n_sfh
 
            aux=((fmu_sfh(i_sfh)-fmu_min)/(fmu_max-fmu_min))*nbin_fmu
            i_fmu_sfh(i_sfh) = 1 + dint(aux)
            
            aux = ((mu(i_sfh)-mu_min)/(mu_max-mu_min)) * nbin_mu
            i_mu(i_sfh) = 1 + dint(aux)
            
            aux=((tauv(i_sfh)-tv_min)/(tv_max-tv_min)) * nbin_tv
            i_tauv(i_sfh) = 1 + dint(aux)

            aux=((tvism(i_sfh)-tv_min)/(tv_max-tv_min)) * nbin_tv
            i_tvism(i_sfh) = 1 + dint(aux)

            if (lssfr6(i_sfh).lt.ssfr_min) then
               lssfr6(i_sfh)=ssfr_min !set small sfrs to sfr_min
            endif
            aux=((lssfr6(i_sfh)-ssfr_min)/(ssfr_max-ssfr_min))* nbin_ssfr
            i_lssfr6(i_sfh) = 1 + dint(aux)

            if (lssfr7(i_sfh).lt.ssfr_min) then
               lssfr7(i_sfh)=ssfr_min !set small sfrs to sfr_min
            endif
            aux=((lssfr7(i_sfh)-ssfr_min)/(ssfr_max-ssfr_min))* nbin_ssfr
            i_lssfr7(i_sfh) = 1 + dint(aux)

            if (lssfr8(i_sfh).lt.ssfr_min) then
               lssfr8(i_sfh)=ssfr_min !set small sfrs to sfr_min
            endif
            aux=((lssfr8(i_sfh)-ssfr_min)/(ssfr_max-ssfr_min))* nbin_ssfr
            i_lssfr8(i_sfh) = 1 + dint(aux)

            if (lage_wm(i_sfh).lt.age_min) then
               lage_wm(i_sfh)=age_min !set small ages to age_min
            endif
            aux=((lage_wm(i_sfh)-age_min)/(age_max-age_min))* nbin_age
            i_lage_wm(i_sfh) = 1 + dint(aux)

            if (lage_wr(i_sfh).lt.age_min) then
               lage_wr(i_sfh)=age_min !set small ages to age_min
            endif
            aux=((lage_wr(i_sfh)-age_min)/(age_max-age_min))* nbin_age
            i_lage_wr(i_sfh) = 1 + dint(aux)

            if (ltform(i_sfh).lt.age_min) then
               ltform(i_sfh)=age_min !set small ages to age_min
            endif
            aux=((ltform(i_sfh)-age_min)/(age_max-age_min))* nbin_age
            i_ltform(i_sfh) = 1 + dint(aux)

         enddo
          

         do i_ir=1, n_ir

            aux=((fmu_ir(i_ir)-fmu_min)/(fmu_max-fmu_min)) * nbin_fmu
            i_fmu_ir(i_ir) = 1+dint(aux)

            aux=((fmu_ism(i_ir)-fmuism_min)/(fmuism_max-fmuism_min))*nbin_fmu_ism
            i_fmu_ism(i_ir) = 1+dint(aux)

            aux=((tbg1(i_ir)-tbg1_min)/(tbg1_max-tbg1_min))* nbin_tbg1
            i_tbg1(i_ir) = 1+dint(aux)

            aux=((tbg2(i_ir)-tbg2_min)/(tbg2_max-tbg2_min))* nbin_tbg2
            i_tbg2(i_ir) = 1+dint(aux)

            aux=((xi1(i_ir)-xi_min)/(xi_max-xi_min)) * nbin_xi
            i_xi1(i_ir) = 1+dint(aux)

            aux=((xi2(i_ir)-xi_min)/(xi_max-xi_min)) * nbin_xi
            i_xi2(i_ir) = 1+dint(aux)

            aux=((xi3(i_ir)-xi_min)/(xi_max-xi_min)) * nbin_xi
            i_xi3(i_ir) = 1+dint(aux)

         enddo

          

         do i_torus=1,ntorus

            aux=((torus_rm(i_torus)-torus_rm_min)/(torus_rm_max-
     2		torus_rm_min)) * nbin_torus_rm
            i_torus_rm(i_torus) = 1+dint(aux)

            aux=((torus_ct(i_torus)-torus_ct_min)/(torus_ct_max-
     2		torus_ct_min)) * nbin_torus_ct
            i_torus_ct(i_torus) = 1+dint(aux)

            aux=((torus_ta(i_torus)-torus_ta_min)/(torus_ta_max-
     2		torus_ta_min)) * nbin_torus_ta
            i_torus_ta(i_torus) = 1+dint(aux)

           aux=((torus_be(i_torus)-torus_be_min)/(torus_be_max-
     2		torus_be_min)) * nbin_torus_be
            i_torus_be(i_torus) = 1+dint(aux)

           aux=((torus_al(i_torus)-torus_al_min)/(torus_al_max-
     2		torus_al_min)) * nbin_torus_al
            i_torus_al(i_torus) = 1+dint(aux)

           aux=((torus_plw(i_torus)-torus_plw_min)/(torus_plw_max-
     2		torus_plw_min)) * nbin_torus_plw
            i_torus_plw(i_torus) = 1+dint(aux)

           aux=((torus_phi(i_torus)-torus_phi_min)/(torus_phi_max-
     2		torus_phi_min)) * nbin_torus_phi
            i_torus_phi(i_torus) = 1+dint(aux)

            aux=((tau_los(i_torus)-torus_ta_min)/(torus_ta_max-
     2		torus_ta_min)) * nbin_torus_ta
            i_tau_los(i_torus) = 1+dint(aux)

         enddo

c     ---------------------------------------------------------------------------
c     HERE STARTS THE ACTUAL FIT
c
c     For each model in the stellar library, find all the models in the infrared
c     dust emission library for which the proportion of dust luminosity from stellar
c     birth clouds and diffuse ISM is the same, i.e. same "fmu" parameter (+/- df)
c     Scale each infrared model satisfying this condition to the total dust 
c     luminosity Ldust predicted by the stellar+attenuation model
c     [this satisfies the energy balance]
c
c     
c     For each combination of model, compute the chi^2 goodness-of-fit
c     by comparing the observed UV-to-IR fluxes with the model predictions
c
c     The scaling factor "a" is in practice the stellar mass of the model
c     since all the fluxes are normalised to Mstar
c
c     The probability of each model is p=exp(-chi^2/2)
c     Compute marginal likelihood distributions of each parameter
c     and build high-resolution histogram of each PDF
c     ---------------------------------------------------------------------------

!	I am going to sample the libraries and normalization randomly



	! inizialize random seed (see RAN1 function)
	
	CALL date_and_time(day,hour)
	READ(hour(5:10),*) DUMMY		! hour(5:10) represents seconds
	ISEED1 = -1*INT(DUMMY*10)
	ISEED2 = -1*INT(DUMMY*10)
	ISEED3 = -1*INT(DUMMY*10)
	ISEED4 = -1*INT(DUMMY*10)

         write(*,*) 'Starting fit.......'


         DO i_ste=1,n_ran_opt


c     Check progress of the fit...
            if (i_ste.eq.(n_ran_opt/4)) then
               write (*,*) '25% done...', i_ste, " / ", n_ran_opt, 
     2		" opt. models"
            else if (i_ste.eq.(n_ran_opt/2)) then
               write (*,*) '50% done...', i_ste, " / ", n_ran_opt, 
     2		" opt. models"
            else if (i_ste.eq.(3*n_ran_opt/4)) then
               write (*,*) '75% done...', i_ste, " / ", n_ran_opt, 
     2		" opt. models"
            else if (i_ste/n_ran_opt.eq.1) then
               write (*,*) '100% done...', n_ran_opt, 
     2		" opt. models - fit finished"
            endif

	 
            i_sfh = nint(RAN1(iseed1)*float(n_sfh-1))+1 	
            

            df=0.15              

c     Search for the IR models with f_mu within the range set by df
            DO j_ste=1,n_ran_ir

               i_ir = nint(RAN1(iseed2)*float(n_ir-1))+1 	


               if (abs(fmu_sfh(i_sfh)-fmu_ir(i_ir)).le.df) then

		  
		  
		  if(print_all_out .eq. 1) then
		     write(33,'(i7,i3,i7)')indx(i_sfh),kfile(i_sfh),i_ir
		  end if



c     Build the model flux array by adding SFH & IR                 
                  do k=1,nfilt_sfh-nfilt_mix
                     flux_mod(k)=flux_sfh(i_sfh,k)
                  enddo
                  do k=nfilt_sfh-nfilt_mix+1,nfilt_sfh
                     flux_mod(k)=flux_sfh(i_sfh,k)+
     +                    ldust(i_sfh)*flux_ir(i_ir,k-nfilt_sfh+nfilt_mix) 
                  enddo
                  do k=nfilt_sfh+1,nfilt
                   flux_mod(k)=ldust(i_sfh)*flux_ir(i_ir,k-nfilt_sfh+nfilt_mix)
                  enddo          

                  
		  do k_ste=1,n_ran_norm

                      a=10.**(a_hist(nint(ran1(iseed3)*float(nbin_a-1))+1))	

                      do k=1,nfilt
		  	 flux_res(k)=0.0
		      end do
		  
                      do k=1,nfilt_sfh
                        if (flux_obs(i_gal,k).gt.0) then   
                          flux_res(k)=flux_obs(i_gal,k)-a*flux_mod(k)
                        endif
                      enddo 

                      do k=nfilt_sfh+1,nfilt
                        if (flux_obs(i_gal,k).gt.0) then                  
                           flux_res(k)=flux_obs(i_gal,k)-a*flux_mod(k)
                        endif
                      enddo


                      do m_ste=1,dummy_do_torus		!n_ran_torus

                  n_models=n_models+1 !to keep track of total number of combinations
		      
		      
			   
                          if (use_rdn_t.eq.1) then
				  i_torus=nint(ran1(iseed4)*float(tot_torus-1))+1	
			  else if (use_rdn_t.eq.0) then
			  	  i_torus=m_ste
			  end if	      
                          
			  
			  
			  num=0.
                          den=0.
                          chi2=0.
                          chi2_opt=0.
                          chi2_ir=0.
                          chi2_nd=0.
			  

                      do k=1,nfilt
                         if (flux_obs(i_gal,k).gt.0.d0
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).le.1000.0) then			
			    num=num+(flux_torus(i_torus,k)*flux_res(k)
     2			    *w(i_gal,k))
                            den=den+((flux_torus(i_torus,k)**2)*w(i_gal,k))
                         endif
                      enddo
                      a_torus=num/den

		      l_accretion=dlog10(a_torus+1.d-30)+46	
		      
		      if(a_torus .le. 0.0d0) then
		      	a_torus=0.0d0
			l_accretion=0.0d0
		      end if
		      
		
c     Compute chi^2 goodness-of-fit
                      do k=1,nfilt_sfh		
		      
		      
		      
			 
                         if (flux_obs(i_gal,k).gt.0.d0 
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).le.1000.0) then                  
                           
			   chi2=chi2+(((flux_obs(i_gal,k)-(a*flux_mod(k))-
     2			   (a_torus*flux_torus(i_torus,k)))**2)*w(i_gal,k))
                           chi2_opt=chi2
			   
                         else if (flux_obs(i_gal,k).gt.0.d0 
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).gt.1000.0) then
                           
			   chi2=chi2+(((flux_obs(i_gal,k)-
     2			   (a*flux_mod(k)))**2)*w(i_gal,k))
                           chi2_opt=chi2

			 endif

		     
			
			if(use_up_lim.eq.1)then
			
                         if (flux_obs(i_gal,k).lt.0
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).le.1000.0) then
                           
			   chi2_nd=chi2_nd+2*dlog(0.5*(1.
     +                     +derf((sigma(i_gal,k)-(a*flux_mod(k))-
     2			   (a_torus*flux_torus(i_torus,k)))
     2                     /(sigma(i_gal,k)*sqrt(2.)))))

                         else if (flux_obs(i_gal,k).lt.0
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).gt.1000.0) then
			   
			   chi2_nd=chi2_nd+2*dlog(0.5*(1.
     +                     +derf((sigma(i_gal,k)-a*flux_mod(k))
     2                     /(sigma(i_gal,k)*sqrt(2.)))))

			 endif
 			
			end if	
 
                      enddo 
			  
		      
                  if (chi2.lt.600.) then	! IR part
                      do k=nfilt_sfh+1,nfilt

			 
                        if (flux_obs(i_gal,k).gt.0.d0 
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).le.1000.0) then                  
                          
			  chi2=chi2+(((flux_obs(i_gal,k)-(a*flux_mod(k))-
     2			  (a_torus*flux_torus(i_torus,k)))**2)*w(i_gal,k))
                          
			  chi2_ir=chi2_ir+(((flux_obs(i_gal,k)-(a*flux_mod(k))-
     2			  (a_torus*flux_torus(i_torus,k)))**2)*w(i_gal,k))
                        
			else if (flux_obs(i_gal,k).gt.0.d0
     2			 .and.sigma(i_gal,k).gt.0. 
     2			 .and. lambda_rest(k).gt.1000.0) then                  
                          
			  chi2=chi2+(((flux_obs(i_gal,k)-
     2			  (a*flux_mod(k)))**2)*w(i_gal,k))
                          
			  chi2_ir=chi2_ir+(((flux_obs(i_gal,k)-
     2			  (a*flux_mod(k)))**2)*w(i_gal,k))

     			end if



			
			if(use_up_lim.eq.1)then
			
                         if (flux_obs(i_gal,k).lt.0
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).le.1000.0) then
                           
			   chi2_nd=chi2_nd+2*dlog(0.5*(1.
     +                     +derf((sigma(i_gal,k)-(a*flux_mod(k))-
     2			   (a_torus*flux_torus(i_torus,k)))
     2                     /(sigma(i_gal,k)*sqrt(2.)))))

                         else if (flux_obs(i_gal,k).lt.0
     2			 .and.sigma(i_gal,k).gt.0.
     2			 .and. lambda_rest(k).gt.1000.0) then
			   
			   chi2_nd=chi2_nd+2*dlog(0.5*(1.
     +                     +derf((sigma(i_gal,k)-a*flux_mod(k))
     2                     /(sigma(i_gal,k)*sqrt(2.)))))

			 endif

			end if	

                      enddo
                  endif




		agn_fraction=(LIR_torus(i_torus)*a_torus)/
     2		  (LIR_torus(i_torus)*a_torus+LIR_sf(i_ir)*ldust(i_sfh)*a)
		log_agn_fraction=dlog10(agn_fraction)
		
		lir_tot=LIR_torus(i_torus)*a_torus+LIR_sf(i_ir)*ldust(i_sfh)*a
		lir_starform=LIR_sf(i_ir)*ldust(i_sfh)*a
		lir_agn=LIR_torus(i_torus)*a_torus
		

		lmir1_tot=LMIR1_torus(i_torus)*a_torus+			! 1.0-2.5 micron	
     +		lmir1_sfh(i_sfh)*a
		lmir2_tot=Lmir2_torus(i_torus)*a_torus+			! 2.5-5.0 micron
     +		Lmir2_sf(i_ir)*ldust(i_sfh)*a+Lmir2_sfh(i_sfh)*a
		lmir3_tot=Lmir3_torus(i_torus)*a_torus+			! 5.0-10.0 micron
     +		Lmir3_sf(i_ir)*ldust(i_sfh)*a+Lmir3_sfh(i_sfh)*a
		lmir4_tot=Lmir4_torus(i_torus)*a_torus+			! 10.0-20.0 micron	
     +		Lmir4_sf(i_ir)*ldust(i_sfh)*a+Lmir4_sfh(i_sfh)*a
		lmir5_tot=Lmir5_torus(i_torus)*a_torus+			! 20.0-40.0 micron
     +		Lmir5_sf(i_ir)*ldust(i_sfh)*a+Lmir5_sfh(i_sfh)*a
		lmir6_tot=Lmir6_torus(i_torus)*a_torus+			! 5.0-40.0 micron
     +		Lmir6_sf(i_ir)*ldust(i_sfh)*a+Lmir6_sfh(i_sfh)*a

		lmir1_agn=LMIR1_torus(i_torus)*a_torus
		lmir2_agn=LMIR2_torus(i_torus)*a_torus
		lmir3_agn=LMIR3_torus(i_torus)*a_torus
		lmir4_agn=LMIR4_torus(i_torus)*a_torus
		lmir5_agn=LMIR5_torus(i_torus)*a_torus
		lmir6_agn=LMIR6_torus(i_torus)*a_torus

		agn_mir1_fraction=lmir1_agn/lmir1_tot
		agn_mir2_fraction=lmir2_agn/lmir2_tot
		agn_mir3_fraction=lmir3_agn/lmir3_tot
		agn_mir4_fraction=lmir4_agn/lmir4_tot
		agn_mir5_fraction=lmir5_agn/lmir5_tot
		agn_mir6_fraction=lmir6_agn/lmir6_tot




c     Probability
                      chi2=chi2-chi2_nd		
		      
		      prob=dexp(-0.5d0*chi2)
                      ptot=ptot+prob
		      
c     Best fit model
                      chi2_new=chi2
                      chi2_new_opt=chi2_opt
                      chi2_new_ir=chi2_ir
		     
		      if (chi2_new.lt.chi2_sav) then
			chi2_sav=chi2_new
                        sfh_sav=i_sfh
                        ir_sav=i_ir
                        a_sav=a
			torus_sav=i_torus
			a_torus_sav=a_torus
                        chi2_sav_opt=chi2_new_opt
                        chi2_sav_ir=chi2_new_ir
			agn_fraction_sav=agn_fraction
			lir_tot_sav=lir_tot
			lir_agn_sav=lir_agn
			lir_starform_sav=lir_starform 
			lacc_sav=l_accretion 

			lmir1_tot_sav=lmir1_tot
			lmir2_tot_sav=lmir2_tot
			lmir3_tot_sav=lmir3_tot
			lmir4_tot_sav=lmir4_tot
			lmir5_tot_sav=lmir5_tot
			lmir6_tot_sav=lmir6_tot

			lmir1_agn_sav=lmir1_agn
			lmir2_agn_sav=lmir2_agn
			lmir3_agn_sav=lmir3_agn
			lmir4_agn_sav=lmir4_agn
			lmir5_agn_sav=lmir5_agn
			lmir6_agn_sav=lmir6_agn

			agn_mir1_fraction_sav=agn_mir1_fraction
			agn_mir2_fraction_sav=agn_mir2_fraction
			agn_mir3_fraction_sav=agn_mir3_fraction
			agn_mir4_fraction_sav=agn_mir4_fraction
			agn_mir5_fraction_sav=agn_mir5_fraction
			agn_mir6_fraction_sav=agn_mir6_fraction

                      endif
		      
	      

c     MARGINAL PROBABILITY DENSITY FUNCTIONS
c     Locate each value on the corresponding histogram bin
c     and compute probability histogram
c     (normalize only in the end of the big loop)
c     for now just add up probabilities in each bin

c     f_mu (SFH)               
                  ibin= i_fmu_sfh(i_sfh)
                  ibin = max(1,min(ibin,nbin_fmu))
                  psfh(ibin)=psfh(ibin)+prob                          
c     f_mu (IR)               
                  ibin = i_fmu_ir(i_ir)
                  ibin = max(1,min(ibin,nbin_fmu))
                  pir(ibin)=pir(ibin)+prob
c     mu              
                  ibin= i_mu(i_sfh)
                  ibin = max(1,min(ibin,nbin_mu))
                  pmu(ibin)=pmu(ibin)+prob
c     tauV              
                  ibin= i_tauv(i_sfh)
                  ibin = max(1,min(ibin,nbin_tv))
                  ptv(ibin)=ptv(ibin)+prob
c     tvism              
                  ibin= i_tvism(i_sfh)
                  ibin = max(1,min(ibin,nbin_tv))
                  ptvism(ibin)=ptvism(ibin)+prob
c     sSFR_0.001Gyr
                  ibin= i_lssfr6(i_sfh)
                  ibin = max(1,min(ibin,nbin_sfr))
                  pssfr6(ibin)=pssfr6(ibin)+prob
c     sSFR_0.01Gyr
                  ibin= i_lssfr7(i_sfh)
                  ibin = max(1,min(ibin,nbin_sfr))
                  pssfr7(ibin)=pssfr7(ibin)+prob
c     sSFR_0.1Gyr
                  ibin= i_lssfr8(i_sfh)
                  ibin = max(1,min(ibin,nbin_sfr))
                  pssfr8(ibin)=pssfr8(ibin)+prob
c     Mstar
                  !a=dlog10(a)
                  aux=((dlog10(a)-a_min)/(a_max-a_min)) * nbin_a
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_a))
                  pa(ibin)=pa(ibin)+prob  
c     SFR_0.001Gyr
                  aux=((lssfr6(i_sfh)+dlog10(a)-sfr_min)/(sfr_max-sfr_min))
     +                 * nbin_sfr
                  ibin= 1+dint(aux)
                  ibin = max(1,min(ibin,nbin_sfr))
                  psfr6(ibin)=psfr6(ibin)+prob
c     SFR_0.01Gyr
                  aux=((lssfr7(i_sfh)+dlog10(a)-sfr_min)/(sfr_max-sfr_min))
     +                 * nbin_sfr
                  ibin= 1+dint(aux)
                  ibin = max(1,min(ibin,nbin_sfr))
                  psfr7(ibin)=psfr7(ibin)+prob
c     SFR_0.1Gyr
                  aux=((lssfr8(i_sfh)+dlog10(a)-sfr_min)/(sfr_max-sfr_min))
     +                 * nbin_sfr
                  ibin= 1+dint(aux)
                  ibin = max(1,min(ibin,nbin_sfr))
                  psfr8(ibin)=psfr8(ibin)+prob
c     Ldust
                  aux=((logldust(i_sfh)+dlog10(a)-ld_min)/(ld_max-ld_min)) 
     +                 * nbin_ld
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_ld))
                  pldust(ibin)=pldust(ibin)+prob  
c     xi_C^tot
                  ibin= i_fmu_ism(i_ir)
                  ibin = max(1,min(ibin,nbin_fmu_ism))
                  pism(ibin)=pism(ibin)+prob 
c     T_C^ISM
                  ibin= i_tbg1(i_ir)
                  ibin = max(1,min(ibin,nbin_tbg1))
                  ptbg1(ibin)=ptbg1(ibin)+prob
c     T_W^BC
                  ibin= i_tbg2(i_ir)
                  ibin = max(1,min(ibin,nbin_tbg2))
                  ptbg2(ibin)=ptbg2(ibin)+prob
c     xi_PAH^tot
                  ibin= i_xi1(i_ir)
                  ibin = max(1,min(ibin,nbin_xi))
                  pxi1(ibin)=pxi1(ibin)+prob
c     xi_MIR^tot
                  ibin= i_xi2(i_ir)
                  ibin = max(1,min(ibin,nbin_xi))
                  pxi2(ibin)=pxi2(ibin)+prob
c     xi_W^tot
                  ibin= i_xi3(i_ir)
                  ibin = max(1,min(ibin,nbin_xi))
                  pxi3(ibin)=pxi3(ibin)+prob
c     Mdust
                  lmdust(i_ir)=dlog10(mdust(i_ir)*ldust(i_sfh)*a)
                  aux=((lmdust(i_ir)-md_min)/(md_max-md_min))*nbin_md
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_md))
                  pmd(ibin)=pmd(ibin)+prob
c     age_wm
                  ibin= i_lage_wm(i_sfh)
                  ibin = max(1,min(ibin,nbin_age))
                  page_wm(ibin)=page_wm(ibin)+prob
c     age_wr
                  ibin= i_lage_wr(i_sfh)
                  ibin = max(1,min(ibin,nbin_age))
                  page_wr(ibin)=page_wr(ibin)+prob
c     tform
                  ibin= i_ltform(i_sfh)
                  ibin = max(1,min(ibin,nbin_age))
                  ptform(ibin)=ptform(ibin)+prob


!	torus

                  ibin= i_torus_rm(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_rm))
                  ptorus_rm(ibin)=ptorus_rm(ibin)+prob

                  ibin= i_torus_ct(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_ct))
                  ptorus_ct(ibin)=ptorus_ct(ibin)+prob

                  ibin= i_torus_ta(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_ta))
                  ptorus_ta(ibin)=ptorus_ta(ibin)+prob
 
                  ibin= i_torus_be(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_be))
                  ptorus_be(ibin)=ptorus_be(ibin)+prob

                  ibin= i_torus_al(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_al))
                  ptorus_al(ibin)=ptorus_al(ibin)+prob

                  ibin= i_torus_plw(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_plw))
                  ptorus_plw(ibin)=ptorus_plw(ibin)+prob

                  ibin= i_torus_phi(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_phi))
                  ptorus_phi(ibin)=ptorus_phi(ibin)+prob
 
                  ibin= i_tau_los(i_torus)
                  ibin = max(1,min(ibin,nbin_torus_ta))
                  ptau_los(ibin)=ptau_los(ibin)+prob


		  a_torus_tmp=a_torus			
                  a_torus=dlog10(a_torus)
                  aux=((a_torus-a_torus_min)/(a_torus_max-a_torus_min))
     2			*nbin_a_torus
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_a_torus))
                  pa_torus(ibin)=pa_torus(ibin)+prob  

                  aux=((dlog10(agn_fraction)-agn_frac_min)/(agn_frac_max-
     2		  agn_frac_min)) * nbin_agn_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_frac))
                  pagn_frac(ibin)=pagn_frac(ibin)+prob  

                  aux=((log10(lir_tot)-lirtot_min)/(lirtot_max-
     2		  lirtot_min)) * nbin_lirtot
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_lirtot))
                  plirtot(ibin)=plirtot(ibin)+prob  

                  aux=((log10(lir_agn)-liragn_min)/(liragn_max-
     2		  liragn_min)) * nbin_liragn
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_liragn))
                  pliragn(ibin)=pliragn(ibin)+prob  

                  aux=((log10(lir_starform)-lirsf_min)/(lirsf_max-
     2		  lirsf_min)) * nbin_lirsf
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_lirsf))
                  plirsf(ibin)=plirsf(ibin)+prob  

                  aux=((l_accretion-lacc_min)/(lacc_max-
     2		  lacc_min)) * nbin_lacc
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_lacc))
                  placc(ibin)=placc(ibin)+prob  



 
                  aux=((dlog10(agn_mir1_fraction)-agn_mir1_frac_min)/
     2		  (agn_mir1_frac_max-agn_mir1_frac_min)) * nbin_agn_mir1_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir1_frac))
                  pagn_mir1_frac(ibin)=pagn_mir1_frac(ibin)+prob  
     
                  aux=((dlog10(agn_mir2_fraction)-agn_mir2_frac_min)/
     2		  (agn_mir2_frac_max-agn_mir2_frac_min)) * nbin_agn_mir2_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir2_frac))
                  pagn_mir2_frac(ibin)=pagn_mir2_frac(ibin)+prob  

                  aux=((dlog10(agn_mir3_fraction)-agn_mir3_frac_min)/
     2		  (agn_mir3_frac_max-agn_mir3_frac_min)) * nbin_agn_mir3_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir3_frac))
                  pagn_mir3_frac(ibin)=pagn_mir3_frac(ibin)+prob  

                  aux=((dlog10(agn_mir4_fraction)-agn_mir4_frac_min)/
     2		  (agn_mir4_frac_max-agn_mir4_frac_min)) * nbin_agn_mir4_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir4_frac))
                  pagn_mir4_frac(ibin)=pagn_mir4_frac(ibin)+prob  

                  aux=((dlog10(agn_mir5_fraction)-agn_mir5_frac_min)/
     2		  (agn_mir5_frac_max-agn_mir5_frac_min)) * nbin_agn_mir5_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir5_frac))
                  pagn_mir5_frac(ibin)=pagn_mir5_frac(ibin)+prob  

                  aux=((dlog10(agn_mir6_fraction)-agn_mir6_frac_min)/
     2		  (agn_mir6_frac_max-agn_mir6_frac_min)) * nbin_agn_mir6_frac
                  ibin=1+dint(aux)
                  ibin = max(1,min(ibin,nbin_agn_mir6_frac))
                  pagn_mir6_frac(ibin)=pagn_mir6_frac(ibin)+prob  



 		if(print_pho_pdf.eq.1)then 
                 do n_ste=1,nfilt
		
                   aux=((dlog10(a*flux_mod(n_ste)*1.d23/
     2		   3.283608731d-33/(dist(i_gal)**2))
     2		   -flux_min)/(flux_max-flux_min)) * nbin_flux
                   ibin=1+dint(aux)
                   ibin = max(1,min(ibin,nbin_flux))
                   pflux_sfir(n_ste,ibin)=pflux_sfir(n_ste,ibin)+prob  
		
                   aux=((dlog10(a_torus_tmp*flux_torus(i_torus,n_ste)*1.d23/
     2		   3.283608731d-33/(dist(i_gal)**2))
     2		   -flux_min)/(flux_max-flux_min)) * nbin_flux
                   ibin=1+dint(aux)
                   ibin = max(1,min(ibin,nbin_flux))
                   pflux_agn(n_ste,ibin)=pflux_agn(n_ste,ibin)+prob  

                   aux=((dlog10((a*flux_mod(n_ste)+
     2		   a_torus_tmp*flux_torus(i_torus,n_ste))*1.d23/
     2		   3.283608731d-33/(dist(i_gal)**2))
     2		   -flux_min)/(flux_max-flux_min)) * nbin_flux
                   ibin=1+dint(aux)
                   ibin = max(1,min(ibin,nbin_flux))
                   pflux_tot(n_ste,ibin)=pflux_tot(n_ste,ibin)+prob  
		   
		  end do	
		end if 


		 end do		
		end do 		
               endif            
            ENDDO               
         ENDDO                  

         if(print_all_out .eq. 1) then
		close(33)
	 end if

c     Chi2-weighted models: normalize to total probability ptot         
         write(*,*) 'Number of random SFH models:       ', n_ran_opt
         write(*,*) 'Number of IR dust emission models: ', n_ran_ir
         write(*,*) 'Number of torus emission models:   ', dummy_do_torus		
         write(*,*) 'Value of df:                       ', df
         write(*,*) 'Total number of models attempted within df:  ', n_models
         write(*,*) 'ptot= ',ptot
         write(*,*) 'chi2_optical= ',chi2_sav_opt
         write(*,*) 'chi2_infrared= ',chi2_sav_ir
         write(*,*) 'chi2= ',chi2_sav

c     ---------------------------------------------------------------------------
c     Compute percentiles of the (normalized) likelihood distributions
c     ---------------------------------------------------------------------------
         do i=1,1500
            psfh(i)=psfh(i)/ptot
            pir(i)=pir(i)/ptot
            pmu(i)=pmu(i)/ptot
            ptv(i)=ptv(i)/ptot
            ptvism(i)=ptvism(i)/ptot
            psfr6(i)=psfr6(i)/ptot
            psfr7(i)=psfr7(i)/ptot
            psfr8(i)=psfr8(i)/ptot
            pssfr6(i)=pssfr6(i)/ptot
            pssfr7(i)=pssfr7(i)/ptot
            pssfr8(i)=pssfr8(i)/ptot
            pa(i)=pa(i)/ptot
            pldust(i)=pldust(i)/ptot
            pism(i)=pism(i)/ptot
            ptbg1(i)=ptbg1(i)/ptot
            ptbg2(i)=ptbg2(i)/ptot
            pxi1(i)=pxi1(i)/ptot
            pxi2(i)=pxi2(i)/ptot          
            pxi3(i)=pxi3(i)/ptot
            pmd(i)=pmd(i)/ptot
            page_wm(i)=page_wm(i)/ptot
            page_wr(i)=page_wr(i)/ptot
            ptform(i)=ptform(i)/ptot

	    ptorus_rm(i) =ptorus_rm(i) /ptot
	    ptorus_ct(i) =ptorus_ct(i) /ptot
	    ptorus_ta(i) =ptorus_ta(i) /ptot
	    ptorus_be(i) =ptorus_be(i) /ptot
	    ptorus_al(i) =ptorus_al(i) /ptot
	    ptorus_plw(i)=ptorus_plw(i)/ptot
	    ptorus_phi(i)=ptorus_phi(i)/ptot
	    ptau_los(i) =ptau_los(i) /ptot
            
	    pa_torus(i)=pa_torus(i)/ptot
	    pagn_frac(i)=pagn_frac(i)/ptot
	    
	    plirtot(i)=plirtot(i)/ptot
	    pliragn(i)=pliragn(i)/ptot
	    plirsf(i)=plirsf(i)/ptot
	    placc(i)=placc(i)/ptot

!	    plmir1tot(i)=plmir1tot(i)/ptot
!	    plmir2tot(i)=plmir2tot(i)/ptot
!	    plmir3tot(i)=plmir3tot(i)/ptot
!	    plmir4tot(i)=plmir4tot(i)/ptot
!	    plmir5tot(i)=plmir5tot(i)/ptot

!	    plmir1agn(i)=plmir1agn(i)/ptot
!	    plmir2agn(i)=plmir2agn(i)/ptot
!	    plmir3agn(i)=plmir3agn(i)/ptot
!	    plmir4agn(i)=plmir4agn(i)/ptot
!	    plmir5agn(i)=plmir5agn(i)/ptot
	    
	    pagn_mir1_frac(i)=pagn_mir1_frac(i)/ptot
	    pagn_mir2_frac(i)=pagn_mir2_frac(i)/ptot
	    pagn_mir3_frac(i)=pagn_mir3_frac(i)/ptot
	    pagn_mir4_frac(i)=pagn_mir4_frac(i)/ptot
	    pagn_mir5_frac(i)=pagn_mir5_frac(i)/ptot
	    pagn_mir6_frac(i)=pagn_mir6_frac(i)/ptot
	    
	    if(print_pho_pdf.eq.1)then 
	     do j=1,nfilt
	    	
		pflux_sfir(j,i)=pflux_sfir(j,i)/ptot
		pflux_agn(j,i)=pflux_agn(j,i)/ptot
		pflux_tot(j,i)=pflux_tot(j,i)/ptot
	    	
	     end do
	    end if ! on print_pho_pdf=1


         enddo
         
         call get_percentiles(nbin_fmu,fmu_hist,psfh,pct_fmu_sfh)
         call get_percentiles(nbin_fmu,fmu_hist,pir,pct_fmu_ir)
         call get_percentiles(nbin_mu,mu_hist,pmu,pct_mu)
         call get_percentiles(nbin_tv,tv_hist,ptv,pct_tv)
         call get_percentiles(nbin_tv,tv_hist,ptvism,pct_tvism)
         call get_percentiles(nbin_ssfr,ssfr_hist,pssfr6,pct_ssfr6)
         call get_percentiles(nbin_ssfr,ssfr_hist,pssfr7,pct_ssfr7)
         call get_percentiles(nbin_ssfr,ssfr_hist,pssfr8,pct_ssfr8)
         call get_percentiles(nbin_sfr,sfr_hist,psfr6,pct_sfr6)
         call get_percentiles(nbin_sfr,sfr_hist,psfr7,pct_sfr7)
         call get_percentiles(nbin_sfr,sfr_hist,psfr8,pct_sfr8)
         call get_percentiles(nbin_a,a_hist,pa,pct_mstr)
         call get_percentiles(nbin_ld,ld_hist,pldust,pct_ld)
         call get_percentiles(nbin_fmu_ism,fmuism_hist,pism,pct_ism)
         call get_percentiles(nbin_tbg1,tbg1_hist,ptbg1,pct_tbg1)
         call get_percentiles(nbin_tbg2,tbg2_hist,ptbg2,pct_tbg2)
         call get_percentiles(nbin_xi,xi_hist,pxi1,pct_xi1)
         call get_percentiles(nbin_xi,xi_hist,pxi2,pct_xi2)
         call get_percentiles(nbin_xi,xi_hist,pxi3,pct_xi3)
         call get_percentiles(nbin_md,md_hist,pmd,pct_md)
         call get_percentiles(nbin_age,age_hist,page_wm,pct_age_wm)
         call get_percentiles(nbin_age,age_hist,page_wr,pct_age_wr)
         call get_percentiles(nbin_age,age_hist,ptform,pct_tform)

         call get_percentiles(nbin_torus_rm,torus_rm_hist,ptorus_rm,
     2		pct_torus_rm)
         call get_percentiles(nbin_torus_ct,torus_ct_hist,ptorus_ct,
     2		pct_torus_ct)
         call get_percentiles(nbin_torus_ta,torus_ta_hist,ptorus_ta,
     2		pct_torus_ta)
         call get_percentiles(nbin_torus_be,torus_be_hist,ptorus_be,
     2		pct_torus_be)
         call get_percentiles(nbin_torus_al,torus_al_hist,ptorus_al,
     2		pct_torus_al)
         call get_percentiles(nbin_torus_plw,torus_plw_hist,ptorus_plw,
     2		pct_torus_plw)
         call get_percentiles(nbin_torus_phi,torus_phi_hist,ptorus_phi,
     2		pct_torus_phi)
         call get_percentiles(nbin_a_torus,a_torus_hist,pa_torus,
     2		pct_a_torus)
         call get_percentiles(nbin_agn_frac,agn_frac_hist,pagn_frac,
     2		pct_agn_frac)
         call get_percentiles(nbin_torus_ta,torus_ta_hist,ptau_los,
     2		pct_tau_los)

         call get_percentiles(nbin_lirtot,lirtot_hist,plirtot,
     2		pct_lirtot)
         call get_percentiles(nbin_liragn,liragn_hist,pliragn,
     2		pct_liragn)
         call get_percentiles(nbin_lirsf,lirsf_hist,plirsf,
     2		pct_lirsf)
         call get_percentiles(nbin_lacc,lacc_hist,placc,
     2		pct_lacc)


         call get_percentiles(nbin_agn_mir1_frac,agn_mir1_frac_hist,
     2		pagn_mir1_frac,pct_agn_mir1_frac)

         call get_percentiles(nbin_agn_mir2_frac,agn_mir2_frac_hist,
     2		pagn_mir2_frac,pct_agn_mir2_frac)

         call get_percentiles(nbin_agn_mir3_frac,agn_mir3_frac_hist,
     2		pagn_mir3_frac,pct_agn_mir3_frac)

         call get_percentiles(nbin_agn_mir4_frac,agn_mir4_frac_hist,
     2		pagn_mir4_frac,pct_agn_mir4_frac)

         call get_percentiles(nbin_agn_mir5_frac,agn_mir5_frac_hist,
     2		pagn_mir5_frac,pct_agn_mir5_frac)

         call get_percentiles(nbin_agn_mir6_frac,agn_mir6_frac_hist,
     2		pagn_mir6_frac,pct_agn_mir6_frac)
 
	 if(print_pho_pdf.eq.1)then 
 	  do j=1,nfilt
 

        	call get_percentiles(nbin_flux,flux_hist,
     2		pflux_sfir(j,:),pct_flux_sfir(j,:))

        	call get_percentiles(nbin_flux,flux_hist,
     2		pflux_agn(j,:),pct_flux_agn(j,:))

        	call get_percentiles(nbin_flux,flux_hist,
     2		pflux_tot(j,:),pct_flux_tot(j,:))

  	  end do
	 end if 


c     ---------------------------------------------------------------------------
c     Degrade the resolution of the likelihood distribution histograms
c     from 1500 max bins to 100 max bins for storing in output file + plotting
c     ---------------------------------------------------------------------------
         do i=1,100
            psfh2(i)=0.
            pir2(i)=0.
            pmu2(i)=0.
            ptv2(i)=0.
            ptvism2(i)=0.
            pssfr62(i)=0.
            pssfr72(i)=0.
            pssfr82(i)=0.
            psfr62(i)=0.
            psfr72(i)=0.
            psfr82(i)=0.
            pa2(i)=0.
            pldust2(i)=0.
            pism2(i)=0.
            ptbg1_2(i)=0.
            ptbg2_2(i)=0.
            pxi1_2(i)=0.
            pxi2_2(i)=0.
            pxi3_2(i)=0.
            pmd_2(i)=0.
            page_wm2(i)=0.
            page_wr2(i)=0.
            ptform2(i)=0.

	    ptorus_rm2(i)=0.		
	    ptorus_ct2(i)=0.
	    ptorus_ta2(i)=0.
	    ptorus_be2(i)=0.
	    ptorus_al2(i)=0.
	    ptorus_plw2(i)=0.
	    ptorus_phi2(i)=0.
	    ptau_los2(i)=0.

	    pa_torus2(i)=0.
	    pagn_frac2(i)=0.

	    plirtot2(i)=0.
	    pliragn2(i)=0.
	    plirsf2(i)=0.
	    placc2(i)=0.


	    pagn_mir1_frac2(i)=0.
	    pagn_mir2_frac2(i)=0.
	    pagn_mir3_frac2(i)=0.
	    pagn_mir4_frac2(i)=0.
	    pagn_mir5_frac2(i)=0.
	    pagn_mir6_frac2(i)=0.
	    
	    
	    if(print_pho_pdf.eq.1)then 
	     do j=1,nfilt
	    
	    	pflux_sfir2(j,i)=0.
	    	pflux_agn2(j,i)=0.
	    	pflux_tot2(j,i)=0.
	    
	     end do
	    end if ! on print_pho_pdf=1
	    

         enddo

c     New histogram parameters
         dfmu=0.05
         fmu_min=0.
         fmu_max=1.
         dfmu_ism=0.05
         fmuism_min=0.
         fmuism_max=1.
         dtv=0.125
         dtvism=0.075
         tv_min=0.
         tv_max=6.
         dssfr=0.10
         ssfr_min=-13.0
         ssfr_max=-6.0
         dsfr=0.10
         sfr_min=-3.
         sfr_max=3.
         da=0.10
         a_min=7.0	
         a_max=13.0	
         dtbg=1.
         tbg2_min=15.
         tbg2_max=25.
         tbg1_min=30.
         tbg1_max=60.
         dxi=0.05
         dmd=0.10
         md_min=3.
         md_max=9.
         dage=0.10
         age_min=7.05
         age_max=10.15

    ! only few modifications for torus
         torus_rm_min=20.
	 torus_rm_max=350
	 dtorus_rm=10.
         torus_ct_min=10.
	 torus_ct_max=70.
	 dtorus_ct=10.
	 torus_ta_min=0.
	 torus_ta_max=10.
	 dtorus_ta=0.1
         torus_be_min=-1.1
	 torus_be_max=0.1
	 dtorus_be=0.1
	 torus_al_min=-0.1
	 torus_al_max=10.0
	 dtorus_al=0.1
         torus_plw_min=-1.1
	 torus_plw_max=-0.
	 dtorus_plw=0.1
	 torus_phi_min=0.
	 torus_phi_max=90.
	 dtorus_phi=1.
         a_torus_min=-10.	
	 a_torus_max=10.	
	 da_torus=0.05
	 dagn_frac=0.05
	 dlirtot=0.05
	 dliragn=0.05
	 dlirsf=0.05
	 dlacc=0.05

	 dagn_mir1_frac=0.05
	 dagn_mir2_frac=0.05
	 dagn_mir3_frac=0.05
	 dagn_mir4_frac=0.05
	 dagn_mir5_frac=0.05
	 dagn_mir6_frac=0.05

	 
	 ! no modifications for photometry PDFs

	if(print_pho_pdf.eq.1)then 
	 
	 dflux=0.05
	 flux_min=-8.
	 flux_max=2.
	 
	end if ! on print_pho_pdf=1



         call degrade_hist(dfmu,fmu_min,fmu_max,nbin_fmu,nbin2_fmu,
     +        fmu_hist,fmu2_hist,psfh,psfh2)    
         call degrade_hist(dfmu,fmu_min,fmu_max,nbin_fmu,nbin2_fmu,
     +        fmu_hist,fmu2_hist,pir,pir2)
         call degrade_hist(dfmu,fmu_min,fmu_max,nbin_mu,nbin2_mu,
     +        mu_hist,mu2_hist,pmu,pmu2)
         call degrade_hist(dtv,tv_min,tv_max,nbin_tv,nbin2_tv,tv_hist,
     +        tv2_hist,ptv,ptv2)
         call degrade_hist(dtvism,tv_min,tv_max,nbin_tv,nbin2_tvism,
     +        tv_hist,tvism2_hist,ptvism,ptvism2)
         call degrade_hist(dssfr,ssfr_min,ssfr_max,nbin_ssfr,nbin2_ssfr,
     +        ssfr_hist,ssfr2_hist,pssfr6,pssfr62)
         call degrade_hist(dssfr,ssfr_min,ssfr_max,nbin_ssfr,nbin2_ssfr,
     +        ssfr_hist,ssfr2_hist,pssfr7,pssfr72)
         call degrade_hist(dssfr,ssfr_min,ssfr_max,nbin_ssfr,nbin2_ssfr,
     +        ssfr_hist,ssfr2_hist,pssfr8,pssfr82)
         call degrade_hist(dsfr,sfr_min,sfr_max,nbin_sfr,nbin2_sfr,
     +        sfr_hist,sfr2_hist,psfr6,psfr62)
         call degrade_hist(dsfr,sfr_min,sfr_max,nbin_sfr,nbin2_sfr,
     +        sfr_hist,sfr2_hist,psfr7,psfr72)
         call degrade_hist(dsfr,sfr_min,sfr_max,nbin_sfr,nbin2_sfr,
     +        sfr_hist,sfr2_hist,psfr8,psfr82)
         call degrade_hist(da,a_min,a_max,nbin_a,nbin2_a,a_hist,
     +        a2_hist,pa,pa2)
         call degrade_hist(da,a_min,a_max,nbin_ld,nbin2_ld,ld_hist,
     +        ld2_hist,pldust,pldust2)
         call degrade_hist(dfmu_ism,fmuism_min,fmuism_max,
     +        nbin_fmu_ism,nbin2_fmu_ism,
     +        fmuism_hist,fmuism2_hist,pism,pism2)
         call degrade_hist(dtbg,tbg1_min,tbg1_max,nbin_tbg1,
     +        nbin2_tbg1,
     +        tbg1_hist,tbg1_2_hist,ptbg1,ptbg1_2)
         call degrade_hist(dtbg,tbg2_min,tbg2_max,nbin_tbg2,
     +        nbin2_tbg2,
     +        tbg2_hist,tbg2_2_hist,ptbg2,ptbg2_2)
         call degrade_hist(dxi,fmu_min,fmu_max,nbin_xi,nbin2_xi,
     +        xi_hist,xi2_hist,pxi1,pxi1_2)
         call degrade_hist(dxi,fmu_min,fmu_max,nbin_xi,nbin2_xi,
     +        xi_hist,xi2_hist,pxi2,pxi2_2)
         call degrade_hist(dxi,fmu_min,fmu_max,nbin_xi,nbin2_xi,
     +        xi_hist,xi2_hist,pxi3,pxi3_2)
         call degrade_hist(dmd,md_min,md_max,nbin_md,nbin2_md,
     +        md_hist,md2_hist,pmd,pmd_2)
         call degrade_hist(dage,age_min,age_max,nbin_age,nbin2_age,
     +        age_hist,age2_hist,page_wm,page_wm2)
         call degrade_hist(dage,age_min,age_max,nbin_age,nbin2_age,
     +        age_hist,age2_hist,page_wr,page_wr2)
         call degrade_hist(dage,age_min,age_max,nbin_age,nbin2_age,
     +        age_hist,age2_hist,ptform,ptform2)


!	torus

         call degrade_hist(dtorus_rm,torus_rm_min,torus_rm_max,
     2	 nbin_torus_rm,nbin2_torus_rm,torus_rm_hist,torus_rm2_hist,
     3	 ptorus_rm,ptorus_rm2)

         call degrade_hist(dtorus_ct,torus_ct_min,torus_ct_max,
     2	 nbin_torus_ct,nbin2_torus_ct,torus_ct_hist,torus_ct2_hist,
     3	 ptorus_ct,ptorus_ct2)

         call degrade_hist(dtorus_ta,torus_ta_min,torus_ta_max,
     2	 nbin_torus_ta,nbin2_torus_ta,torus_ta_hist,torus_ta2_hist,
     3	 ptorus_ta,ptorus_ta2)

         call degrade_hist(dtorus_be,torus_be_min,torus_be_max,
     2	 nbin_torus_be,nbin2_torus_be,torus_be_hist,torus_be2_hist,
     3	 ptorus_be,ptorus_be2)

         call degrade_hist(dtorus_al,torus_al_min,torus_al_max,
     2	 nbin_torus_al,nbin2_torus_al,torus_al_hist,torus_al2_hist,
     3	 ptorus_al,ptorus_al2)

         call degrade_hist(dtorus_plw,torus_plw_min,torus_plw_max,
     2	 nbin_torus_plw,nbin2_torus_plw,torus_plw_hist,torus_plw2_hist,
     3	 ptorus_plw,ptorus_plw2)

         call degrade_hist(dtorus_phi,torus_phi_min,torus_phi_max,
     2	 nbin_torus_phi,nbin2_torus_phi,torus_phi_hist,torus_phi2_hist,
     3	 ptorus_phi,ptorus_phi2)

         call degrade_hist(da_torus,a_torus_min,a_torus_max,
     2	 nbin_a_torus,nbin2_a_torus,a_torus_hist,a_torus2_hist,
     3	 pa_torus,pa_torus2)

         call degrade_hist(dagn_frac,agn_frac_min,agn_frac_max,
     2	 nbin_agn_frac,nbin2_agn_frac,agn_frac_hist,agn_frac2_hist,
     3	 pagn_frac,pagn_frac2)

         call degrade_hist(dlirtot,lirtot_min,lirtot_max,
     2	 nbin_lirtot,nbin2_lirtot,lirtot_hist,lirtot2_hist,
     3	 plirtot,plirtot2)

         call degrade_hist(dliragn,liragn_min,liragn_max,
     2	 nbin_liragn,nbin2_liragn,liragn_hist,liragn2_hist,
     3	 pliragn,pliragn2)

         call degrade_hist(dlirsf,lirsf_min,lirsf_max,
     2	 nbin_lirsf,nbin2_lirsf,lirsf_hist,lirsf2_hist,
     3	 plirsf,plirsf2)

         call degrade_hist(dlacc,lacc_min,lacc_max,
     2	 nbin_lacc,nbin2_lacc,lacc_hist,lacc2_hist,
     3	 placc,placc2)

         call degrade_hist(dtorus_ta,torus_ta_min,torus_ta_max,
     2	 nbin_torus_ta,nbin2_torus_ta,torus_ta_hist,torus_ta2_hist,
     3	 ptau_los,ptau_los2)




         call degrade_hist(dagn_mir1_frac,agn_mir1_frac_min,agn_mir1_frac_max,
     2	 nbin_agn_mir1_frac,nbin2_agn_mir1_frac,agn_mir1_frac_hist,
     2	 agn_mir1_frac2_hist,pagn_mir1_frac,pagn_mir1_frac2)

         call degrade_hist(dagn_mir2_frac,agn_mir2_frac_min,agn_mir2_frac_max,
     2	 nbin_agn_mir2_frac,nbin2_agn_mir2_frac,agn_mir2_frac_hist,
     2	 agn_mir2_frac2_hist,pagn_mir2_frac,pagn_mir2_frac2)

         call degrade_hist(dagn_mir3_frac,agn_mir3_frac_min,agn_mir3_frac_max,
     2	 nbin_agn_mir3_frac,nbin2_agn_mir3_frac,agn_mir3_frac_hist,
     2	 agn_mir3_frac2_hist,pagn_mir3_frac,pagn_mir3_frac2)

         call degrade_hist(dagn_mir4_frac,agn_mir4_frac_min,agn_mir4_frac_max,
     2	 nbin_agn_mir4_frac,nbin2_agn_mir4_frac,agn_mir4_frac_hist,
     2	 agn_mir4_frac2_hist,pagn_mir4_frac,pagn_mir4_frac2)

         call degrade_hist(dagn_mir5_frac,agn_mir5_frac_min,agn_mir5_frac_max,
     2	 nbin_agn_mir5_frac,nbin2_agn_mir5_frac,agn_mir5_frac_hist,
     2	 agn_mir5_frac2_hist,pagn_mir5_frac,pagn_mir5_frac2)

         call degrade_hist(dagn_mir6_frac,agn_mir6_frac_min,agn_mir6_frac_max,
     2	 nbin_agn_mir6_frac,nbin2_agn_mir6_frac,agn_mir6_frac_hist,
     2	 agn_mir6_frac2_hist,pagn_mir6_frac,pagn_mir6_frac2)




	if(print_pho_pdf.eq.1)then 
	 
	 do j=1,nfilt
	 
	 
        	call degrade_hist(dflux,flux_min,flux_max,
     2		nbin_flux,nbin2_flux,flux_hist,
     2	 	flux_2_hist,pflux_sfir(j,:),pflux_sfir2(j,:))
	 
        	call degrade_hist(dflux,flux_min,flux_max,
     2		nbin_flux,nbin2_flux,flux_hist,
     2	 	flux_2_hist,pflux_agn(j,:),pflux_agn2(j,:))
	 
        	call degrade_hist(dflux,flux_min,flux_max,
     2		nbin_flux,nbin2_flux,flux_hist,
     2	 	flux_2_hist,pflux_tot(j,:),pflux_tot2(j,:))
	 
	 end do
	 
	end if 


c     ---------------------------------------------------------------------------
c     Store fit results in .fit output file
c     ---------------------------------------------------------------------------
         write(31,702)
 702     format('# OBSERVED FLUXES (and errors):')
         write(filter_header,*) (filt_name(k),k=1,nfilt)
         write(31,*) '#  '//filter_header(1:largo(filter_header))

         write(31,701) (flux_obs(i_gal,k),k=1,nfilt)
         write(31,701) (sigma(i_gal,k),k=1,nfilt)
         write(31,703)
 703     format('#')

         write(31,800)
 800     format('# ... Results of fitting the fluxes to the model.....')
 802     format('#..tform.......age_wm......age_wr',
     +        '......fmu(SFH)...fmu(IR).......mu......tauv',
     +        '.......sSFR6.......sSFR7.......sSFR8..........M*.......Ldust',
     +        '......T_W^BC....T_C^ISM..xi_C^tot',
     +        '.xi_PAH^tot.xi_MIR^tot.xi_W^tot..tvism',
     +        '...Mdust......SFR6........SFR7........SFR8')
 822	format('# ...torus_rm....torus_ct',
     +	      '....torus_ta.....torus_be....torus_al....',
     +	      'torus_plw..torus_phi..a_torus.....agn_frac',
     +	      '....L(IR,tot)...L(IR,SF)....L(IR,AGN)....L(acc)',
     +        '....tau(9.7,l.o.s.)')
 803     format(0p3e12.3,1p4f10.3,1p5e12.3,0p2f10.1,0p5f10.3,1p4e12.3)
 823	 format(0p7f12.2,1p6e12.3,0p1f12.2)

 920     format('# ... Mid-IR results (best fit): ',
     +          'AGN fractions in the marked wavelength ranges (microns) ...')
! 921     format('#..L(1-5,tot)....L(1-5,AGN)....agn_frac(1-5)',
!     +	      '....L(5-10,tot)....L(5-10,AGN)....agn_frac(5-10)',
!     +	      '....L(10-20,tot)....L(10-20,AGN)....agn_frac(10-20)',
!     +	      '....L(20-40,tot)....L(20-40,AGN)....agn_frac(20-40)',
!     +	      '....L(5-40,tot)....L(5-40,AGN)....agn_frac(5-40)')
 921     format('#...(1.0-2.5)',
     +	      '...(2.5-5.0)',
     +	      '....(5-10)',
     +	      '....(10-20)',
     +	      '.....(20-40)',
     +	      '.....(5-40)')
! 922	 format(0p15e12.3)
 922	 format(0p6e12.3)
      
         write(31,703)
         write(31,804)
 804     format('# BEST FIT MODEL: (i_sfh, i_ir, i_torus, chi2, redshift)')
         write(31,311) indx(sfh_sav),ir_sav,torus_sav,chi2_sav/n_flux,
     +        redshift(i_gal)
 311     format(3i10,0pf10.3,0pf12.6)

         write(31,703)
         write(31,802)
         write(31,803) tform(sfh_sav),age_wm(sfh_sav),age_wr(sfh_sav),
     +	      fmu_sfh(sfh_sav),fmu_ir(ir_sav),mu(sfh_sav),
     +        tauv(sfh_sav),ssfr6(sfh_sav),ssfr7(sfh_sav),ssfr8(sfh_sav),
     +        a_sav,ldust(sfh_sav)*a_sav,tbg1(ir_sav),tbg2(ir_sav),
     +        fmu_ism(ir_sav),xi1(ir_sav),
     +        xi2(ir_sav),xi3(ir_sav),
     +        tvism(sfh_sav),mdust(ir_sav)*a_sav*ldust(sfh_sav),
     +        ssfr6(sfh_sav)*a_sav,ssfr7(sfh_sav)*a_sav,ssfr8(sfh_sav)*a_sav
         write(31,703)
     	 write(31,822)
	 write(31,823) torus_rm(torus_sav),torus_ct(torus_sav),torus_ta(torus_sav),
     +	      torus_be(torus_sav),torus_al(torus_sav),torus_plw(torus_sav),
     +	      torus_phi(torus_sav),a_torus_sav,agn_fraction_sav,lir_tot_sav,
     +	      lir_starform_sav,lir_agn_sav,lacc_sav,tau_los(torus_sav)
     
 
         write(31,703)
 885	 format('# NOTE: the AGN fraction above was computed ',
     +          'between 8 and 1000 micron')

	 write(31,885)
         write(31,703)
         write(31,920)
         write(31,921)
!         write(31,922) lmir1_tot_sav, lmir1_agn_sav, agn_mir1_fraction_sav,
!     +   lmir2_tot_sav, lmir2_agn_sav, agn_mir2_fraction_sav,
!     +   lmir3_tot_sav, lmir3_agn_sav, agn_mir3_fraction_sav,
!     +   lmir4_tot_sav, lmir4_agn_sav, agn_mir4_fraction_sav,
!     +   lmir5_tot_sav, lmir5_agn_sav, agn_mir5_fraction_sav
         write(31,922) agn_mir1_fraction_sav,
     +   agn_mir2_fraction_sav,
     +   agn_mir3_fraction_sav,
     +   agn_mir4_fraction_sav,
     +   agn_mir5_fraction_sav,
     +   agn_mir6_fraction_sav

         write(31,703)
         write(31,*) '#  '//filter_header(1:largo(filter_header))
         !write(31,703)
         write(31,701) (a_sav*flux_sfh(sfh_sav,k)+
     2	      a_torus_sav*flux_torus(torus_sav,k),k=1,nfilt_sfh-nfilt_mix),
     3        (a_sav*(flux_sfh(sfh_sav,k)
     4        +flux_ir(ir_sav,k-nfilt_sfh+nfilt_mix)*ldust(sfh_sav))+
     5        a_torus_sav*flux_torus(torus_sav,k),
     6        k=nfilt_sfh-nfilt_mix+1,nfilt_sfh),
     7        (a_sav*flux_ir(ir_sav,k-nfilt_sfh+nfilt_mix)*ldust(sfh_sav)+
     8        a_torus_sav*flux_torus(torus_sav,k),k=nfilt_sfh+1,nfilt)
 701     format(1p70e12.3)

         write(31,703)
         write(31,805)
 805     format('# MARGINAL PDF HISTOGRAMS FOR EACH PARAMETER......')

 807     format(0pf10.4,1pe12.3e3)
 60      format('#....percentiles of the PDF......')
 61      format(0p5f8.3)
 62      format(1p5e12.3e3)

         write(31,882)
 882     format('# ... tform ...')
         do ibin=1,nbin2_age
            write(31,826) age2_hist(ibin),ptform2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tform(k),k=1,5)

         write(31,883)
 883     format('# ... age_wm (Mass-weighted age) ...')
         do ibin=1,nbin2_age
            write(31,826) age2_hist(ibin),page_wm2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_age_wm(k),k=1,5)

         write(31,884)
 884     format('# ... age_wr (R-band weighted age) ...')
         do ibin=1,nbin2_age
            write(31,826) age2_hist(ibin),page_wr2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_age_wr(k),k=1,5)

         write(31,806)
 806     format('# ... f_mu (SFH) ...')
         do ibin=1,nbin2_fmu
            write(31,807) fmu2_hist(ibin),psfh2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_fmu_sfh(k),k=1,5)

         write(31,808)
 808     format('# ... f_mu (IR) ...')
         do ibin=1,nbin2_fmu
            write(31,807) fmu2_hist(ibin),pir2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_fmu_ir(k),k=1,5)

         write(31,809)
 809     format('# ... mu parameter ...')
         do ibin=1,nbin2_mu
            write(31,807) mu2_hist(ibin),pmu2(ibin)
         enddo        
         write(31,60)
         write(31,61) (pct_mu(k),k=1,5)

         write(31,810)
 810     format('# ... tau_V ...')
         do ibin=1,nbin2_tv
            write(31,807) tv2_hist(ibin),ptv2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tv(k),k=1,5)

         write(31,811)
 811     format('# ... sSFR_0.001Gyr ...')
         do ibin=1,nbin2_ssfr
            write(31,812) ssfr2_hist(ibin),pssfr62(ibin)
         enddo
 812     format(1p2e12.3e3)
         write(31,60)
         write(31,62) (pct_ssfr6(k),k=1,5)

         write(31,825)
 825     format('# ... sSFR_0.01Gyr ...')
         do ibin=1,nbin2_ssfr
            write(31,826) ssfr2_hist(ibin),pssfr72(ibin)
         enddo
 826     format(1p2e12.3e3)
         write(31,60)
         write(31,62) (pct_ssfr7(k),k=1,5)

         write(31,827)
 827     format('# ... sSFR_0.1Gyr ...')
         do ibin=1,nbin2_ssfr
            write(31,826) ssfr2_hist(ibin),pssfr82(ibin)
         enddo
 828     format(1p2e12.3e3)
         write(31,60)
         write(31,62) (pct_ssfr8(k),k=1,5)

         write(31,813)
 813     format('# ... M(stars) ...')
         do ibin=1,nbin2_a
            write(31,812) a2_hist(ibin),pa2(ibin)
         enddo
         write(31,60)
         write(31,62) (pct_mstr(k),k=1,5)

         write(31,814)
 814     format('# ... Ldust ...')
         do ibin=1,nbin2_ld
            write(31,812) ld2_hist(ibin),pldust2(ibin)
         enddo
         write(31,60)
         write(31,62) (pct_ld(k),k=1,5)

         write(31,815)
 815     format('# ... T_C^ISM ...')
         do ibin=1,nbin2_tbg2
            write(31,807) tbg2_2_hist(ibin),ptbg2_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tbg2(k),k=1,5)

         write(31,820)
 820     format('# ... T_W^BC ...')
         do ibin=1,nbin2_tbg1
            write(31,807) tbg1_2_hist(ibin),ptbg1_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tbg1(k),k=1,5)

         write(31,821)
 821     format('# ... xi_C^tot ...')
         do ibin=1,nbin2_fmu_ism
            write(31,807) fmuism2_hist(ibin),pism2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_ism(k),k=1,5)

         write(31,816)
 816     format('# ... xi_PAH^tot ...')
         do ibin=1,nbin2_xi
            write(31,807) xi2_hist(ibin),pxi1_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_xi1(k),k=1,5)

         write(31,817)
 817     format('# ... xi_MIR^tot ...')
         do ibin=1,nbin2_xi
            write(31,807) xi2_hist(ibin),pxi2_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_xi2(k),k=1,5)

         write(31,818)
 818     format('# ... xi_W^tot ...')
         do ibin=1,nbin2_xi
            write(31,807) xi2_hist(ibin),pxi3_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_xi3(k),k=1,5)

         write(31,81)
 81      format('# ... tau_V^ISM...')
         do ibin=1,nbin2_tvism
            write(31,807) tvism2_hist(ibin),ptvism2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tvism(k),k=1,5)

         write(31,888)
 888     format('# ... M(dust)...')
         do ibin=1,nbin2_md
            write(31,807) md2_hist(ibin),pmd_2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_md(k),k=1,5)

         write(31,889)
 889     format('# ... SFR_0.001Gyr ...')
         do ibin=1,nbin2_sfr
            write(31,812) sfr2_hist(ibin),psfr62(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_sfr6(k),k=1,5)

         write(31,886)
 886     format('# ... SFR_0.01Gyr ...')
         do ibin=1,nbin2_sfr
            write(31,812) sfr2_hist(ibin),psfr72(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_sfr7(k),k=1,5)

         write(31,887)
 887     format('# ... SFR_0.1Gyr ...')
         do ibin=1,nbin2_sfr
            write(31,812) sfr2_hist(ibin),psfr82(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_sfr8(k),k=1,5)

         write(31,890)
 890     format('# ... torus rm ...')
         do ibin=1,nbin2_torus_rm
            write(31,812) torus_rm2_hist(ibin),ptorus_rm2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_rm(k),k=1,5)

         write(31,891)
 891     format('# ... torus ct ...')
         do ibin=1,nbin2_torus_ct
            write(31,812) torus_ct2_hist(ibin),ptorus_ct2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_ct(k),k=1,5)

         write(31,892)
 892     format('# ... torus ta ...')
         do ibin=1,nbin2_torus_ta
            write(31,812) torus_ta2_hist(ibin),ptorus_ta2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_ta(k),k=1,5)

         write(31,893)
 893     format('# ... torus be ...')
         do ibin=1,nbin2_torus_be
            write(31,812) torus_be2_hist(ibin),ptorus_be2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_be(k),k=1,5)

         write(31,894)
 894     format('# ... torus al ...')
         do ibin=1,nbin2_torus_al
            write(31,812) torus_al2_hist(ibin),ptorus_al2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_al(k),k=1,5)

         write(31,895)
 895     format('# ... torus plw ...')
         do ibin=1,nbin2_torus_plw
            write(31,812) torus_plw2_hist(ibin),ptorus_plw2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_plw(k),k=1,5)

         write(31,896)
 896     format('# ... torus phi ...')
         do ibin=1,nbin2_torus_phi
            write(31,812) torus_phi2_hist(ibin),ptorus_phi2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_torus_phi(k),k=1,5)

         write(31,897)
 897     format('# ... torus normalization ...')
         do ibin=1,nbin2_a_torus
            write(31,812) a_torus2_hist(ibin),pa_torus2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_a_torus(k),k=1,5)

         write(31,898)
 898     format('# ... agn fraction ...')
         do ibin=1,nbin2_agn_frac
            write(31,812) agn_frac2_hist(ibin),pagn_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_frac(k),k=1,5)

         write(31,899)
 899     format('# ... L(IR,tot) ...')
         do ibin=1,nbin2_lirtot
            write(31,812) lirtot2_hist(ibin),plirtot2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_lirtot(k),k=1,5)

         write(31,900)
 900     format('# ... L(IR,AGN) ...')
         do ibin=1,nbin2_liragn
            write(31,812) liragn2_hist(ibin),pliragn2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_liragn(k),k=1,5)

         write(31,901)
 901     format('# ... L(IR,SF) ...')
         do ibin=1,nbin2_lirsf
            write(31,812) lirsf2_hist(ibin),plirsf2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_lirsf(k),k=1,5)

         write(31,902)
 902     format('# ... L(acc) ...')
         do ibin=1,nbin2_lacc
            write(31,812) lacc2_hist(ibin),placc2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_lacc(k),k=1,5)


         write(31,905)
 905     format('# ... agn fraction (1.0-2.5 um)...')
         do ibin=1,nbin2_agn_mir1_frac
            write(31,812) agn_mir1_frac2_hist(ibin),pagn_mir1_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir1_frac(k),k=1,5)


         write(31,908)
 908     format('# ... agn fraction (2.5-5.0 um)...')
         do ibin=1,nbin2_agn_mir2_frac
            write(31,812) agn_mir2_frac2_hist(ibin),pagn_mir2_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir2_frac(k),k=1,5)


         write(31,911)
 911     format('# ... agn fraction (5-10 um)...')
         do ibin=1,nbin2_agn_mir3_frac
            write(31,812) agn_mir3_frac2_hist(ibin),pagn_mir3_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir3_frac(k),k=1,5)


         write(31,914)
 914     format('# ... agn fraction (10-20 um)...')
         do ibin=1,nbin2_agn_mir4_frac
            write(31,812) agn_mir4_frac2_hist(ibin),pagn_mir4_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir4_frac(k),k=1,5)


         write(31,917)
 917     format('# ... agn fraction (20-40 um)...')
         do ibin=1,nbin2_agn_mir5_frac
            write(31,812) agn_mir5_frac2_hist(ibin),pagn_mir5_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir5_frac(k),k=1,5)



         write(31,923)
 923     format('# ... agn fraction (5-40 um)...')
         do ibin=1,nbin2_agn_mir6_frac
            write(31,812) agn_mir6_frac2_hist(ibin),pagn_mir6_frac2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_agn_mir6_frac(k),k=1,5)


         write(31,924)
 924     format('# ... tau(9.7um, along the line of sight)...')
         do ibin=1,nbin2_torus_ta
            write(31,812) torus_ta2_hist(ibin),ptau_los2(ibin)
         enddo
         write(31,60)
         write(31,61) (pct_tau_los(k),k=1,5)


c     ---------------------------------------------------------------------------
c     Store SED results in .sed output file
c     ---------------------------------------------------------------------------

         write(*,*) 'Storing best-fit SED...'
         write(*,*) outfile2

	 if(indx(sfh_sav).gt.0 .and. ir_sav.gt.0 .and. torus_sav.gt.0) then 
	        call get_bestfit_sed(indx(sfh_sav),ir_sav,a_sav,
     +    	    fmu_sfh(sfh_sav),torus_sav,a_torus_sav,
     +	  	    redshift(i_gal),outfile2,torus_list,
     +		    infile1,infile1b,infile2)
	 else
	 	write(*,*)'No best fit found: no .sed file written!!!'
	 end if



c     ---------------------------------------------------------------------------
c     Store photometry PDFs results in .pho output file
c     ---------------------------------------------------------------------------

	if(print_pho_pdf.eq.1)then 

         write(*,*) 'Storing photometry PDF...'
         write(*,*) outfile4

	 open(34, file=outfile4, status='unknown')

	 write(34,*) 'nfilt',nfilt
	 write(34,*)
	 
	 do j=1,nfilt

	 	write(34,*) 'FILTER ', filt_name(j)
		write(34,*) 'log[Jy], PDF_SF+DUST, PDF_AGN, PDF_TOT'
         
		 do ibin=1,nbin2_flux
        	    write(34,950) flux_2_hist(ibin),pflux_sfir2(j,ibin),
     2		    pflux_agn2(j,ibin),pflux_tot2(j,ibin)
        	 enddo
		
         	write(34,951)
         	write(34,61) (pct_flux_sfir(j,k),k=1,5)
         	write(34,61) (pct_flux_agn(j,k),k=1,5)
         	write(34,61) (pct_flux_tot(j,k),k=1,5)
		write(34,*)	 	 
	 
	 
	
	 end do  ! on j=nfilt


	 close(34)
	 
	end if ! on print_pho_pdf=1

 950	format(1p4e12.3e3)
 951    format('#....percentiles of the PDF (SF+Dust, AGN, Tot)......')



c     ---------------------------------------------------------------------------
c     ---------------------------------------------------------------------------
c     ---------------------------------------------------------------------------





	! end time

	CALL date_and_time(day,hour)
	en_h=hour(1:2)
	en_m=hour(3:4)
	en_s=hour(5:10)
	en_day=day(7:8)
	en_mnt=day(5:6)
	en_y=day(1:4)



	WRITE(*,*) 'FINISHED!!!'
	
	write(*,*) 'started at ',st_h,':',
     2	st_m,':',st_s,' of ',st_day,'/',st_mnt,'/',st_y
        
	write(*,*) 'ended at ',en_h,':',en_m,':',en_s,' of ',
     4	en_day,'/',en_mnt,'/',en_y







         STOP
         END

c     ===========================================================================
      SUBROUTINE DEGRADE_HIST(delta,min,max,nbin1,nbin2,hist1,hist2,prob1,prob2)
c     ---------------------------------------------------------------------------
c     Degrades the resolution of the histograms containing the likelihood 
c     distribution of the parameters: to facilitate storage & visualization
c     ---------------------------------------------------------------------------
c     delta : bin width
c     min   : minumum value
c     max   : maximum value
c     nbin1 : number of bins of high-res histogram
c     nbin2 : number of bins of output low-res histogram
c     hist1 : input high-res histogram x-axis
c     hist2 : output low-res histogram x-axis
c     prob1 : input histogram values
c     prob2 : output histogram values
c     ===========================================================================
      implicit none
      integer nbin1,nbin2,i,ibin,maxnbin2
      parameter(maxnbin2=200)
      real*8 delta,max,min,max2
      real*8 hist1(nbin1),prob1(nbin1)
      real*8 hist2(maxnbin2),prob2(maxnbin2)
      real*8 aux
      
      max2=0.
      max2=max+(delta/2.)

      call get_histgrid(delta,min,max2,nbin2,hist2)
      
      do i=1,nbin1
         aux=((hist1(i)-min)/(max-min)) * nbin2
         ibin=1+dint(aux)
         prob2(ibin)=prob2(ibin)+prob1(i)
      enddo            

      RETURN
      END

c     ===========================================================================
      SUBROUTINE GET_HISTGRID(dv,vmin,vmax,nbin,vout)
c     ---------------------------------------------------------------------------
c     Build histogram grid (i.e. vector of bins) 
c     ---------------------------------------------------------------------------
c       dv : bin width
c     vmin : minumum value
c     vmax : maximum value
c     nbin : number of bins 
c     vout : output vector of bins
c     ===========================================================================
      implicit none
      integer nbin,ibin,maxnbin
      parameter(maxnbin=5000)
      real*8 vout(maxnbin)
      real*8 vmin,vmax,x1,x2,dv
      
      ibin=1
      x1=vmin
      x2=vmin+dv
      do while (x2.le.vmax)
         vout(ibin)=0.5*(x1+x2)
         ibin=ibin+1
         x1=x1+dv
         x2=x2+dv
      enddo
      nbin=ibin-1
      return
      END

c     ===========================================================================
      SUBROUTINE GET_PERCENTILES(n,par,probability,percentile)
c     ---------------------------------------------------------------------------
c     Calculates percentiles of the probability distibution
c     for a given parameter: 2.5, 16, 50 (median), 84, 97.5
c     1. Sort the parameter + the probability array
c     2. Find the parameter value M for which:
c        P (x < M) = P (x > M) = percentiles
c     ---------------------------------------------------------------------------
c               n : number of points (bins)
c             par : parameter value (vector of bins)
c     probability : vector with prob of each parameter value (or bin)
c      percentile : vector containing 5 percentiles described above
c     ===========================================================================
      integer n,n_perc(5),i
      real*8 par(n),probability(n),pless
      real*8 percentile(5),limit(5)

      data limit/0.025,0.16,0.50,0.84,0.975/

      call sort2(n,par,probability)

      pless=0.      
      do i=1,5
         n_perc(i)=1
         pless=0.
         do while (pless.le.limit(i))
            pless=pless+probability(n_perc(i))
            n_perc(i)=n_perc(i)+1
         enddo
         n_perc(i)=n_perc(i)-1
         percentile(i)=par(n_perc(i))
      enddo

      return
      END

c     ===========================================================================
      SUBROUTINE sort2(n,arr,brr)
c     ---------------------------------------------------------------------------
c     Sorts an array arr(1:n) into ascending order using Quicksort
c     while making the corresponding rearrangement of the array brr(1:n)
c     ===========================================================================
      INTEGER n,M,NSTACK
      REAL*8 arr(n),brr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL*8 a,b,temp
      jstack=0
      l=1
      ir=n
 1    if (ir-l.lt.M) then
         do j=l+1,ir
            a=arr(j)
            b=brr(j)
            do i=j-1,l,-1
               if (arr(i).le.a) goto 2
               arr(i+1)=arr(i)
               brr(i+1)=brr(i)
            enddo
            i=l-1
 2          arr(i+1)=a
            brr(i+1)=b
         enddo
         if (jstack.eq.0) return
         ir=istack(jstack)
         l=istack(jstack-1)
         jstack=jstack-2
      else
         k=(l+ir)/2
         temp=arr(k)
         arr(k)=arr(l+1)
         arr(l+1)=temp
         temp=brr(k)
         brr(k)=brr(l+1)
         brr(l+1)=temp
         if (arr(l).gt.arr(ir)) then
            temp=arr(l)
            arr(l)=arr(ir)
            arr(ir)=temp
            temp=brr(l)
            brr(l)=brr(ir)
            brr(ir)=temp
         endif
         if (arr(l+1).gt.arr(ir)) then
            temp=arr(l+1)
            arr(l+1)=arr(ir)
            arr(ir)=temp
            temp=brr(l+1)
            brr(l+1)=brr(ir)
            brr(ir)=temp
         endif
         if (arr(l).gt.arr(l+1)) then
            temp=arr(l)
            arr(l)=arr(l+1)
            arr(l+1)=temp
            temp=brr(l)
            brr(l)=brr(l+1)
            brr(l+1)=temp
         endif
         i=l+1
         j=ir
         a=arr(l+1)
         b=brr(l+1)
 3       continue
         i=i+1
         if (arr(i).lt.a) goto 3
 4       continue
         j=j-1
         if (arr(j).gt.a) goto 4
         if (j.lt.i) goto 5
         temp=arr(i)
         arr(i)=arr(j)
         arr(j)=temp
         temp=brr(i)
         brr(i)=brr(j)
         brr(j)=temp
         goto 3
 5       arr(l+1)=arr(j)
         arr(j)=a
         brr(l+1)=brr(j)
         brr(j)=b
         jstack=jstack+2
         if (jstack.gt.NSTACK) pause 'NSTACK too small in sort2'
         if (ir-i+1.ge.j-l) then
            istack(jstack)=ir
            istack(jstack-1)=i
            ir=j-1
         else
            istack(jstack)=j-1
            istack(jstack-1)=l
            l=i
         endif
      endif
      goto 1
      END


c     ===========================================================================
      REAL*8 FUNCTION DL(h,q,z)
c     ---------------------------------------------------------------------------
c     Computes luminosity distance corresponding to a redshift z.
c     Uses Mattig formulae for qo both 0 and non 0
c     Revised January 1991 to implement cosmolgical constant
c     Ho in km/sec/Mpc, DL is in Mpc
c     ===========================================================================
      implicit none
      real*8 h, q, z, d1, d2
      real*8 aa, bb, epsr, s, s0, funl
      real*8 dd1, dd2, omega0
      logical success
      integer npts
      external funl
      common /cosm/ omega0

      if (z.le.0.) then
         dl=1.e-5               !10 pc
         return
      endif

      if (q .eq. 0) then
         dl = ((3.e5 * z) * (1 + (z / 2.))) / h
      else if (q .gt. 0.) then
         d1 = (q * z) + ((q - 1.) * (sqrt(1. + ((2. * q) * z)) - 1.))
         d2 = ((h * q) * q) / 3.e5
         dl = d1 / d2
      else if (q .lt. 0.) then
         omega0 = (2. * (q + 1.)) / 3.
         aa = 1.
         bb = 1. + z
         success=.false.
         s0=1.e-10
         npts=0
         do while (.not.success)
            npts=npts+1
            call midpnt(funl,aa,bb,s,npts)
            epsr=abs(s-s0)/s0
            if (epsr.lt.1.e-4) then
               success=.true.
            else
               s0=s
            endif
         enddo
         dd1=s
	 dd2 = (3.e5 * (1. + z)) / (h * sqrt(omega0))
	 dl = dd1 * dd2
      end if

      return
      end

c     ===========================================================================
      REAL*8 FUNCTION FUNL(x)
c     ---------------------------------------------------------------------------
c     For non-zero cosmological constant
c     ===========================================================================
      real*8 x, omega0, omegainv
      common /cosm/ omega0
      omegainv = 1. / omega0
      funl = 1. / sqrt(((x ** 3.) + omegainv) - 1.)
      return
      end


c     ===========================================================================
      SUBROUTINE MIDPNT(func,a,b,s,n)
c     ===========================================================================
      INTEGER n
      REAL*8 a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL*8 ddel,del,sum,tnm,x
      if (n.eq.1) then
         s=(b-a)*func(0.5*(a+b))
      else
         it=3**(n-2)
         tnm=it
         del=(b-a)/(3.*tnm)
         ddel=del+del
         x=a+0.5*del
         sum=0.
         do 11 j=1,it
            sum=sum+func(x)
            x=x+ddel
            sum=sum+func(x)
            x=x+del
 11      continue
         s=(s+(b-a)*sum/tnm)/3.
      endif
      return
      END

c     ===========================================================================
      REAL*8 FUNCTION COSMOL_C(h,omega,omega_lambda,q)
c     ---------------------------------------------------------------------------
c     Returns cosmological constant = cosmol_c and parameter q
c
c     Omega is entered by the user
c     omega=1.-omega_lambda
c     ===========================================================================
      real*8 h,omega,omega_lambda,q

c     Cosmological constant
      cosmol_c=omega_lambda/(3.*h**2)
c     Compute q=q0
      if (omega_lambda.eq.0.) then
         q=omega/2.
      else
         q=(3.*omega/2.) - 1.
      endif
      return
      end

c     ===========================================================================
      REAL*8 FUNCTION T(h, q, z, lamb)
c     ---------------------------------------------------------------------------
c     Returns age of universe at redshift z
c     ===========================================================================
      implicit none
      real*8 h, q, z, a, b, c, hh0, cosh, x, lamb
      real*8 aa, bb, epsr, s0, s, funq, omega0
      integer npts
      logical success
      external funq
      common /cosm/ omega0

c     H = Ho in km/sec/Mpc
c     Q = qo  (if problems with qo = 0, try 0.0001)

      a(q,z) = (sqrt(1. + ((2. * q) * z)) / (1. - (2. * q))) / (1. + z)
      b(q) = q / (abs((2. * q) - 1.) ** 1.5)
      c(q,z) = ((1. - (q * (1. - z))) / q) / (1. + z)

      cosh(x) = dlog10(x + sqrt((x ** 2) - 1.))
      hh0 = h * 0.001022
c     in (billion years)**(-1)

      if (lamb .ne. 0.0) then
         omega0 = (2. * (q + 1.)) / 3.
         aa = 0.
         bb = 1. / (1. + z)
         success=.false.
         s0=1.e-10
         npts=0
         do while (.not.success)
            npts=npts+1
            call midpnt(funq,aa,bb,s,npts)
            epsr=abs(s-s0)/s0
            if (epsr.lt.1.e-4) then
               success=.true.
            else
               s0=s
            endif
         enddo
         t=s
      else if (q .eq. 0.0) then
         t = 1. / (1. + z)
      else if (q .lt. 0.5) then
         t = a(q,z) - (b(q) * cosh(c(q,z)))
      else if (q .eq. 0.5) then
         t = (2. / 3.) / ((1. + z) ** 1.5)
      else
         t = a(q,z) + (b(q) * cos(c(q,z)))
      end if

      t = t / hh0

      return
      end


c     ===========================================================================
      REAL*8 FUNCTION FUNQ(x)
c     ---------------------------------------------------------------------------
c     For non-zero cosmological constant
c     ===========================================================================
      real*8 x, omega0, omegainv
      common /cosm/ omega0
      omegainv = 1. / omega0
      funq = sqrt(omegainv) / (x*sqrt((omegainv-1.)+(1./(x**3.))))
      return
      end

c     ===========================================================================
      FUNCTION LARGO(A)
c     ---------------------------------------------------------------------------
c     Returns significant length of string a
c     ===========================================================================
      Character*(*) a
      largo=0
      do i=1,len(a)
         if (a(i:i).ne.' ') largo=i
      enddo
      return
      end


c     ===========================================================================
      SUBROUTINE GET_BESTFIT_SED(i_opt,i_ir,dmstar,dfmu_aux,
     2 i_torus,da_torus,dz,outfile,torus_list,
     + infile1,infile1b,infile2)
c     ---------------------------------------------------------------------------
c     Gets the total (UV-to-infrared) best-fit SED
c     
c     Gets stellar spectrum and dust emission spectra from .bin files
c     and adds them to get total SED, and writes output in .sed file
c     
c        i_opt : index in the Optical library
c         i_ir : index in the Infrared library
c       dmstar : stellar mass (scaling)
c     dfmu_aux : fmu_optical (to check if we got the right model)
!      i_torus : index in the torus library
!      a_torus : normalization for torus model
c           dz : redshift
c      outfile : .sed file (output)
!   torus_list : filename of list of torus models
c     ===========================================================================
      implicit none
      character infile1*80,infile1b*80,infile2*80
      character*20 outfile
      integer nage,niw_opt,niw_ir,niw_tot
      integer i,imod,nburst,k
      integer i_opt,i_ir,indx
      parameter(niw_tot=12817)
      real tform,gamma,zmet,tauv0,mu,mstr1,mstr0,mstry,tlastburst,age_wm,age_wr
      real fmu,ldtot,fbc,aux,lha,lhb
      real wl_opt(6918),opt_sed(6918),opt_sed0(6918)
      real wl_ir(6450),ir_sed(6450),irprop(8)
      real age(1000),sfr(1000)
      real fburst(5),ftot(5),sfrav(5)
      real*8 dfmu_aux,dmstar,dz
      real fmu_aux,mstar,z
      real fmuopt(50000),fmuir(50000)
      real fopt(6918),fopt0(6918),ldust
      real fir(6450),fopt_int(niw_tot),fopt_int0(niw_tot)
      real sedtot(niw_tot),wl(niw_tot)
      real fir_new(niw_tot),fopt_new(niw_tot),fopt_aux(niw_tot)
      real fopt_new0(niw_tot),fopt_aux0(niw_tot)

      integer largo
      character torus_list*50
      character torus_filename*120
      integer io
      integer i_torus
      integer i_ste,ilambda
      integer maxlambda_torus
      parameter (maxlambda_torus=200)
      real*8 torus_lambda(maxlambda_torus)
      real*8 torus_lum(maxlambda_torus)
      real*8 da_torus

      real a_torus
      real ftorus_aux(maxlambda_torus)
      real ltorus_aux(maxlambda_torus)
      real ftorus_int(niw_tot)
      real ftorus_new(niw_tot)
      real sedtot_torus(niw_tot)
      real dummy
      
      mstar=sngl(dmstar)
      fmu_aux=sngl(dfmu_aux)
      z=sngl(dz)
      a_torus=sngl(da_torus)

      !call getenv('OPTILIB',infile1)
      !call getenv('IRLIB',infile2)

      close (29)
      open (29,file=infile1,status='old',form='unformatted')

      close (30)
      open (30,file=infile2,status='old',form='unformatted')

      close (31)
      open (31,file=outfile,status='unknown')
            

      write(31,*) '#...Main parameters of this model:'
      write(31,319)

c     Read Optical SEDs and properties (1st file = models 1 to 25000)
 7    read (29) niw_opt,(wl_opt(i),i=1,niw_opt)
      indx=0
      do imod=1,25000
         indx=indx+1
         read (29,end=1) tform,gamma,zmet,tauv0,mu,nburst,
     .        mstr1,mstr0,mstry,tlastburst,
     .        (fburst(i),i=1,5),(ftot(i),i=1,5),
     .        age_wm,age_wr,aux,aux,aux,aux,
     .        lha,lhb,aux,aux,ldtot,fmu,fbc
         read (29) nage,(age(i),sfr(i),i=1,nage),(sfrav(i),i=1,5)
         sfrav(3)=sfrav(3)/mstr1
         read (29) (opt_sed(i),opt_sed0(i),i=1,niw_opt)
         
         if (indx.eq.i_opt) then
            fmuopt(imod)=fmu
c     Normalise Optical SED by stellar mass of the model
            do i=1,niw_opt
               fopt(i)=opt_sed(i)/mstr1
               fopt0(i)=opt_sed0(i)/mstr1
            enddo
            ldust=ldtot/mstr1
            goto 2
         endif
      enddo

 2    if (int(fmu*1000).eq.int(fmu_aux*1000)
     +     .or.int(fmu*1000).eq.(int(fmu_aux*1000)-1)
     +     .or.int(fmu*1000).eq.(int(fmu_aux*1000)+1)) then
         write(*,*) 'optical... done'
      endif 
      if (int(fmu*1000).ne.int(fmu_aux*1000)
     +     .and.int(fmu*1000).ne.(int(fmu_aux*1000)-1)
     +     .and.int(fmu*1000).ne.(int(fmu_aux*1000)+1) ) then
         !call getenv('OPTILIBIS',infile1b)
         close(29)
         open (29,file=infile1b,status='old',form='unformatted')
         goto 7
      endif
          
c     Read Infrared SEDs and properties
      read (30) niw_ir,(wl_ir(i),i=1,niw_ir)
      do imod=1,50000
         read (30) (irprop(i),i=1,8)	     	      
         read (30) (ir_sed(i),i=1,niw_ir)
         fmuir(imod)=irprop(1)
         if (imod.eq.i_ir) then
            do i=1,niw_ir
               fir(i)=ir_sed(i)
            enddo
            goto 3
         endif
      enddo
 3    write(*,*) 'infrared... done'
      
      write(*,*) 'Ldust/L_sun= ',mstar*ldust



      close (32)
      open (32,file=torus_list(1:largo(torus_list)),status='old')

 
      do i=1,i_torus
         read(32,*) 
      end do
      
      read (32,*) torus_filename
      close (32)
      
      open (32,file=torus_filename,status='old')
      
      ! skip header 4 lines
      do i=1,4
         read(32,*)
      end do
	
      io=0
      ilambda=0
      ! read model
      do while(ilambda.le.(maxlambda_torus-1))
          ilambda=ilambda+1
          read(32,*,iostat=io) torus_lambda(ilambda),
     2    torus_lum(ilambda)
		 
          ! model format is: lambda[um] and luminosity[erg/s/um]
          ! I need to turn it into lambda[A] and luminosity[Lsun/A]
		      
          torus_lambda(ilambda)=torus_lambda(ilambda)*1.d4
          torus_lum(ilambda)=torus_lum(ilambda)/1.d4/3.839d33
		      
      end do
      close (32)

      
      write(31,315)
 315  format('#...fmu(Opt).....fmu(IR)....tform/yr.......gamma',
     +     '........Z/Zo........tauV..........mu.....M*/Msun',
     +     '....SFR(1e8).....Ld/Lsun')
      write(31,316) fmu,irprop(1),tform,gamma,zmet,tauv0,mu,mstar,
     +     sfrav(3),ldust*mstar
 316  format(0p2f12.3,1pe12.3,0p4f12.3,1p3e12.3)
      
      write(31,319)
      write(31,317)
 317  format('#...xi_C^ISM....T_W^BC/K...T_C^ISM/K...xi_PAH^BC',
     +     '...xi_MIR^BC.....xi_W^BC....Mdust/Mo')
      write(31,318) (irprop(k),k=2,7),irprop(8)*ldust*mstar
 318  format(0p6f12.3,1pe12.3)

      write(31,319)
 319  format('#')
      write(31,314)
 314  format('#...Spectral Energy Distribution [lg(L_lambda/LoA^-1)]:')
      write(31,312)
 312  format('#...lg(lambda/A)...Total...Tot_no_AGN...',
     +	'Stars_Unattenuated...Torus...Stars_attenuated...Dusty_SF')


c     Wavelength vectors are not the same for the Optical and IR spectra,
c     nor in the torus model
c     Make new wavelength vector by combining them
      do i=1,6367
         wl(i)=wl_opt(i)
         fir_new(i)=0.
      enddo
      do i=6368,niw_tot
         wl(i)=wl_ir(i-6367)
         fir_new(i)=fir(i-6367)
      enddo

c     Interpolate the optical SED in the new wavelength grid (do it in log)
      do i=1,niw_opt
         fopt_aux(i)=log10(fopt(i))
         fopt_aux0(i)=log10(fopt0(i))           
      enddo

      do i=1,niw_tot
         call interp(wl_opt,fopt_aux,niw_opt,4,wl(i),fopt_int(i))
         fopt_new(i)=10**(fopt_int(i))
         call interp(wl_opt,fopt_aux0,niw_opt,4,wl(i),fopt_int0(i))
         fopt_new0(i)=10**(fopt_int0(i))
      enddo

c     Interpolate the torus SED in the new wavelength grid (do it in log)
      do i=1,maxlambda_torus
         ftorus_aux(i)=log10(sngl(torus_lum(i)))
	 ltorus_aux(i)=sngl(torus_lambda(i))
      end do   

       do i=1,maxlambda_torus
         ftorus_int(i)=0.
         ftorus_new(i)=0.
       end do

      do i=1,niw_tot

	 call interp(ltorus_aux,ftorus_aux,maxlambda_torus,
     2   2,wl(i),ftorus_int(i))

         ftorus_new(i)=10.**(ftorus_int(i))

      end do
 
      
      
      


c     Final SEDs - write output file
      do i=1,niw_tot-1
         sedtot(i)=fopt_new(i)+ldust*fir_new(i)
         sedtot(i)=mstar*sedtot(i)
	 sedtot_torus(i)=sedtot(i)+a_torus*ftorus_new(i)
         fopt_new0(i)=fopt_new0(i)*mstar


         dummy=-45.

         ! check for under-flow & write
      

	 if(log10(a_torus*ftorus_new(i)/(1.+z)).lt.-45.
     +	 .and. log10(ldust*fir_new(i)*mstar/(1.+z)).lt.-45.)then

              write(31,311) log10(wl(i)*(1.+z)),
     +        log10(sedtot_torus(i)/(1.+z)),
     + 	      log10(sedtot(i)/(1.+z)),
     +        log10(fopt_new0(i)/(1.+z)),
     +        dummy,
     +        log10(fopt_new(i)*mstar/(1.+z)),
     +        dummy

	else if(log10(a_torus*ftorus_new(i)/(1.+z)).lt.-45.)then

              write(31,311) log10(wl(i)*(1.+z)),
     +        log10(sedtot_torus(i)/(1.+z)),
     + 	      log10(sedtot(i)/(1.+z)),
     +        log10(fopt_new0(i)/(1.+z)),
     +        dummy,
     +        log10(fopt_new(i)*mstar/(1.+z)),
     +        log10(ldust*fir_new(i)*mstar/(1.+z))
         
	 else if(log10(ldust*fir_new(i)*mstar/(1.+z)).lt.-45.)then

              write(31,311) log10(wl(i)*(1.+z)),
     +        log10(sedtot_torus(i)/(1.+z)),
     + 	      log10(sedtot(i)/(1.+z)),
     +        log10(fopt_new0(i)/(1.+z)),
     +        log10(a_torus*ftorus_new(i)/(1.+z)),
     +        log10(fopt_new(i)*mstar/(1.+z)),
     +        dummy
     
     	else if(wl(i).gt.1000.d4) then			

              write(31,311) log10(wl(i)*(1.+z)),
     +        log10(sedtot(i)/(1.+z)),
     + 	      log10(sedtot(i)/(1.+z)),
     +        log10(fopt_new0(i)/(1.+z)),
     +        dummy,
     +        log10(fopt_new(i)*mstar/(1.+z)),
     +        log10(ldust*fir_new(i)*mstar/(1.+z))
     
     	else

              write(31,311) log10(wl(i)*(1.+z)),
     +        log10(sedtot_torus(i)/(1.+z)),
     + 	      log10(sedtot(i)/(1.+z)),
     +        log10(fopt_new0(i)/(1.+z)),
     +        log10(a_torus*ftorus_new(i)/(1.+z)),
     +        log10(fopt_new(i)*mstar/(1.+z)),
     +        log10(ldust*fir_new(i)*mstar/(1.+z))
         
	 end if
	 
      enddo
 311  format(f12.5,2f12.3,4f15.3)

      return

 1    stop
      end

c     ===========================================================================
      SUBROUTINE INTERP(x,y,npts,nterms,xin,yout)
c     ---------------------------------------------------------------------------
c     INTERPOLATOR
c     description of parameters
c     x      - array of data points for independent variable
c     y      - array of data points for dependent variable
c     npts   - number of pairs of data points
c     nterms - number of terms in fitting polynomial
c     xin    - input value of x
c     yout   - interplolated value of y
c     
c     comments
c     dimension statement valid for nterms up to 10
c     value of nterms may be modified by the program
c     ===========================================================================
      implicit real (a-h,o-z)
      integer npts
      dimension x(npts),y(npts)
      dimension delta(10),a(10)
c     search for appropriate value of x(1)
 11   do 19 i=1,npts
         if (xin-x(i)) 13,17,19
 13      i1 = i-nterms/2
         if (i1) 15,15,21
 15      i1 = 1
         go to 21
 17      yout = y(i)
 18      go to 61
 19   continue
      i1 = npts - nterms + 1
 21   i2 = i1 + nterms -1
      if (npts-i2) 23,31,31
 23   i2 = npts
      i1 = i2 - nterms +1
 25   if (i1) 26,26,31
 26   i1 = 1
 27   nterms = i2 - i1 + 1

c     evaluate deviations delta
 31   denom = x(i1+1) - x(i1)
      deltax = (xin-x(i1))/denom
      do 35 i=1,nterms
         ix = i1 + i - 1
 35      delta(i) = (x(ix)-x(i1))/denom

c     accumulate coefficients a
 40      a(1) = y(i1)
 41      do 50 k=2,nterms
            prod = 1.0
            sum = 0.0
            imax = k-1
            ixmax = i1 + imax
            do 49 i=1,imax
               j = k-i
               prod = prod*(delta(k)-delta(j))
 49            sum = sum - a(j)/prod
 50            a(k) = sum + y(ixmax)/prod

c     accumulate sum of expansion
 51            sum = a(1)
               do 57 j=2,nterms
                  prod = 1.0
                  imax = j-1
                  do 56 i=1,imax
 56                  prod = prod*(deltax-delta(i))
 57                  sum = sum + a(j)*prod
 60                  yout = sum

 61                  return
                     end


	! ----------------------------------------------------
	! ----------------------------------------------------
	! ----------------------------------------------------


	FUNCTION ran1(idum)
	
	! taken from Numerical Recipes
	
	INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
	REAL ran1,AM,EPS,RNMX
	PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     2 	NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)


	INTEGER j,k,iv(NTAB),iy
	SAVE iv,iy
	DATA iv /NTAB*0/, iy /0/
	if (idum.le.0.or.iy.eq.0) then 
		idum=max(-idum,1) 
		do j=NTAB+8,1,-1 
			k=idum/IQ
			idum=IA*(idum-k*IQ)-IR*k
			if (idum.lt.0) idum=idum+IM
			if (j.le.NTAB) iv(j)=idum
		end do 
		iy=iv(1)
	end if

	k=idum/IQ 
	idum=IA*(idum-k*IQ)-IR*k 
	if (idum.lt.0) idum=idum+IM
	j=1+iy/NDIV 
	iy=iv(j) 
	iv(j)=idum
	ran1=min(AM*iy,RNMX) 
	
	return

	END FUNCTION ran1


	! ----------------------------------------------------
	! ----------------------------------------------------
	! ----------------------------------------------------







 
***********************************************************
       SUBROUTINE POLINT(XA,YA,N,X,Y,DY)
       PARAMETER (NMAX=10) 
       DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
       NS=1
       DIF=ABS(X-XA(1))
       DO 11 I=1,N 
         DIFT=ABS(X-XA(I))
         IF (DIFT.LT.DIF) THEN
           NS=I
           DIF=DIFT
         ENDIF
         C(I)=YA(I)
         D(I)=YA(I)
 11    CONTINUE
       Y=YA(NS)
       NS=NS-1
       DO 13 M=1,N-1
         DO 12 I=1,N-M
           HO=XA(I)-X
           HP=XA(I+M)-X
           W=C(I+1)-D(I)
           DEN=HO-HP
           IF(DEN.EQ.0.)PAUSE
           DEN=W/DEN
           D(I)=HP*DEN
           C(I)=HO*DEN
 12      CONTINUE
         IF (2*NS.LT.N-M)THEN
           DY=C(NS+1)
         ELSE
           DY=D(NS)
           NS=NS-1
         ENDIF
         Y=Y+DY
 13    CONTINUE
       RETURN
       END
 
 
***********************************************************
      SUBROUTINE LOCATE(XX,N,X,J)
      DIMENSION XX(N)
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      J=JL
      RETURN
      END



***********************************************************	
	SUBROUTINE POIN(X1A,YA,M,MI,X1,Y,DY)

	PARAMETER(MMAX=10)
	REAL X1A(M),YA(M),X1AI(MMAX),YAI(MMAX)

	MIT=MIN(MI,MMAX,M)

C	localizziamo X1 nel suo array,
C	e quindi prepariamo il "sottoarray" da usare nell'interpolazione
	CALL LOCATE(X1A,M,X1,I)

	MPRIMA=MIT/2
	MDOPO=MIT-MPRIMA

	IF (I.LT.MPRIMA) THEN 
		IBEG=1
	ELSE IF (I.GT.(M-MDOPO)) THEN 
		IBEG=M-MIT+1
	ELSE 
		IBEG=I-MPRIMA+1
	ENDIF

	DO 100,I=0,MIT-1
		X1AI(I+1)=X1A(I+IBEG)
		YAI(I+1)=YA(I+IBEG)
 100	CONTINUE

C	finalmente si interpola
	CALL POLINT(X1AI,YAI,MIT,X1,Y,DY)

	RETURN
	END


***********************************************************	

c       ===========================================================================
	REAL*8 FUNCTION TRAPZ8 (X,Y,N)
c       ===========================================================================
c	Integrates function y(x)
c       n : number of points
c       ---------------------------------------------------------------------------  
	REAL*8 X(N),Y(N)
	integer N,J
	TRAPZ8=0.
	IF (N.LE.1) RETURN
	DO 1 J=2,N
 1	   TRAPZ8= TRAPZ8 + DABS(X(J)-X(J-1))*(Y(J)+Y(J-1))/2.
	   RETURN
 2	   TRAPZ8=Y(1)*X(1)/2.
	   RETURN
	   END
